// DialogEditorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DialogEditor.h"
#include "DialogEditorDlg.h"
#include "PropsDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
   CAboutDlg();
   
   // Dialog Data
   //{{AFX_DATA(CAboutDlg)
   enum { IDD = IDD_ABOUTBOX };
   //}}AFX_DATA
   
   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CAboutDlg)
protected:
   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
   //}}AFX_VIRTUAL
   
   // Implementation
protected:
   //{{AFX_MSG(CAboutDlg)
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
   //{{AFX_DATA_INIT(CAboutDlg)
   //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CAboutDlg)
   //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogEditorDlg dialog

CDialogEditorDlg::CDialogEditorDlg(CWnd* pParent /*=NULL*/)
: CDialog(CDialogEditorDlg::IDD, pParent)
{
   //{{AFX_DATA_INIT(CDialogEditorDlg)
   // NOTE: the ClassWizard will add member initialization here
   //}}AFX_DATA_INIT
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDialogEditorDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CDialogEditorDlg)
   // NOTE: the ClassWizard will add DDX and DDV calls here
   //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDialogEditorDlg, CDialog)
//{{AFX_MSG_MAP(CDialogEditorDlg)
ON_WM_SYSCOMMAND()
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_INSERT_BUTTON, OnInsertButton)
	ON_COMMAND(ID_INSERT_TEXT, OnInsertText)
	ON_COMMAND(ID_CONTROL_PROPERTIES, OnControlProperties)
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_INSERT_PICTURE, OnInsertPicture)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogEditorDlg message handlers


//---------------------------------------------------------------------------------------
BOOL CDialogEditorDlg::OnInitDialog()
{
   CDialog::OnInitDialog();
   
   // Add "About..." menu item to system menu.
   
   // IDM_ABOUTBOX must be in the system command range.
   ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
   ASSERT(IDM_ABOUTBOX < 0xF000);
   
   CMenu* pSysMenu = GetSystemMenu(FALSE);
   if (pSysMenu != NULL)
   {
      CString strAboutMenu;
      strAboutMenu.LoadString(IDS_ABOUTBOX);
      if (!strAboutMenu.IsEmpty())
      {
         pSysMenu->AppendMenu(MF_SEPARATOR);
         pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
      }
   }
   
   SetIcon(m_hIcon, TRUE);			// Set big icon
   SetIcon(m_hIcon, FALSE);		// Set small icon

   // set up dialog editor
   RECT Rect;
   GetWindowRect( &Rect );
   Rect.left += 4; Rect.right -= 8;
   Rect.top += 4; Rect.bottom -= 50;
   MyDialogEditor.Create( NULL, "MyDialogEditorWindow", 
                          WS_CHILD | WS_VISIBLE | WS_BORDER, Rect, this, 0x9998, NULL );
   MyDialogEditor.SetWindowPos( NULL, Rect.left, Rect.top, 0, 0, SWP_NOSIZE );
   
   return TRUE;  // return TRUE  unless you set the focus to a control
}


//---------------------------------------------------------------------------------------
void CDialogEditorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
   if ((nID & 0xFFF0) == IDM_ABOUTBOX)
   {
      CAboutDlg dlgAbout;
      dlgAbout.DoModal();
   }
   else
   {
      CDialog::OnSysCommand(nID, lParam);
   }
}


//---------------------------------------------------------------------------------------
HCURSOR CDialogEditorDlg::OnQueryDragIcon()
{
   return (HCURSOR) m_hIcon;
}


//---------------------------------------------------------------------------------------
void CDialogEditorDlg::OnFileExit() 
{
   EndDialog( IDCANCEL );
}


//---------------------------------------------------------------------------------------
LRESULT CDialogEditorDlg::WindowProc( UINT message, WPARAM wParam, LPARAM lParam ) 
{
   return CDialog::WindowProc( message, wParam, lParam );
}


//---------------------------------------------------------------------------------------
void CDialogEditorDlg::OnInsertButton() 
{
   CMyButton btnstruct;
   btnstruct.x = WS_DEFGRIDSIZE * 10;
   btnstruct.y = WS_DEFGRIDSIZE * 10;
   btnstruct.w = 80;
   btnstruct.h = 40;
   // btnstruct.prop_Default = 1;
   btnstruct.prop_Multiline = 1;
   btnstruct.prop_HorAlign = BS_CENTER;
   btnstruct.prop_VertAlign = BS_VCENTER;
   lstrcpy( btnstruct.prop_Caption, "mybtn\nnextline" );
   wsprintf( btnstruct.CtrlName, "btn_%lu", GetTickCount() );
   if( !MyDialogEditor.AddStruct( &btnstruct, sizeof( CMyButton ) ) )
   {
      // MessageBox( "Fail" );
   }
}


//---------------------------------------------------------------------------------------
void CDialogEditorDlg::OnInsertText() 
{
   CMyTextLabel label;
   label.x = 160 + (char)GetTickCount();
   label.y = 160 + (char)GetTickCount();
   label.w = 100;
   label.h = 20;
   label.prop_AlignText = SS_CENTER;
   label.prop_CenterVertically = 0;
   label.prop_NoWrap = 0;
   label.prop_Border = 1;
   // label.prop_Disabled = 1;
   lstrcpy( label.prop_Caption, "mylabel\nnextline" );
   wsprintf( label.CtrlName, "lbl_%lu", GetTickCount() );
   if( !MyDialogEditor.AddStruct( &label, sizeof( CMyTextLabel ) ) )
   {
      // MessageBox( "Fail" );
   }
}


//---------------------------------------------------------------------------------------
void CDialogEditorDlg::OnInsertPicture() 
{
   CMyPictureBox pb;
   pb.x = 100;
   pb.y = 100;
   pb.w = 100;
   pb.h = 100;
   pb.prop_Tile = 1;
   pb.prop_Border = 0;
   lstrcpy( pb.prop_FileName, "d:\\test.bmp" );
   wsprintf( pb.CtrlName, "pb_%lu", GetTickCount() );
  
   //pb.Image = LoadBitmap( GetModuleHandle( NULL ), MAKEINTRESOURCE( IDB_BITMAP1 ) );
   if( !MyDialogEditor.AddStruct( &pb, sizeof( CMyPictureBox ) ) )
   {
      // MessageBox( "Fail" );
   }
}


//---------------------------------------------------------------------------------------
void CDialogEditorDlg::OnControlProperties() 
{
   CPropsDialog pd;

   // add some ctrls
   CMyPropEditStruct editstruct;
   lstrcpy( editstruct.EditText, "SimpleText" );
   lstrcpy( editstruct.PropName, "Caption" );
   pd.MyProps.AddStruct( &editstruct, sizeof( CMyPropEditStruct ) );

   lstrcpy( editstruct.EditText, "c:\\prg.exe" );
   lstrcpy( editstruct.PropName, "ExeFileName" );
   // set up file open struct
   editstruct.isFileName = 1;
   editstruct.ofn.lStructSize = sizeof( OPENFILENAME );
   editstruct.ofn.lpstrFilter = "Executable Files (*.exe)\0*.exe\0All Files (*.*)\0*.*\0\0";
   editstruct.ofn.lpstrTitle = "Open Custom File";
   editstruct.ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
   editstruct.ofn.nFilterIndex = 0;
   editstruct.ofn.lpstrDefExt = "exe";
   editstruct.ofn.nMaxFile = MAX_PATH;
   editstruct.ofn.lpstrInitialDir = "";
   editstruct.ofn.lpstrFileTitle = "";
   editstruct.ofn.lpstrCustomFilter = NULL;
   editstruct.ofn.nMaxCustFilter = 0;
   editstruct.ofn.nMaxFileTitle = 0;
   editstruct.ofn.nFileOffset = 0;
   editstruct.ofn.nFileExtension = 0;
   editstruct.ofn.lCustData = 0;
   editstruct.ofn.lpfnHook = NULL;
   editstruct.ofn.lpTemplateName = NULL;
   editstruct.isReadOnly = 1;
   pd.MyProps.AddStruct( &editstruct, sizeof( CMyPropEditStruct ) );


   CMyPropBoolStruct bools;
   bools.Result = true;
   lstrcpy( bools.PropName, "TestBoolean" );
   pd.MyProps.AddStruct( &bools, sizeof( CMyPropBoolStruct ) );

   
   CMyPropComboStruct combo;
   lstrcpy( combo.PropName, "TestDropDownCombo" );
   combo.Combotype = MP_CBT_DROPDOWN;
   combo.SelIndex = 0;
   combo.NumOfStrings = 10;
   lstrcpy( combo.Strings[ 0 ], "string 0" );
   lstrcpy( combo.Strings[ 1 ], "string 1" );
   lstrcpy( combo.Strings[ 2 ], "string 2" );
   lstrcpy( combo.Strings[ 3 ], "string 3" );
   lstrcpy( combo.Strings[ 4 ], "string 4" );
   lstrcpy( combo.Strings[ 5 ], "string 5" );
   lstrcpy( combo.Strings[ 6 ], "string 6" );
   lstrcpy( combo.Strings[ 7 ], "string 7" );
   lstrcpy( combo.Strings[ 8 ], "string 8" );
   lstrcpy( combo.Strings[ 9 ], "string 9" );
   lstrcpy( combo.SelText, combo.Strings[ 0 ] );
   pd.MyProps.AddStruct( &combo, sizeof( CMyPropComboStruct ) );

   combo.Combotype = MP_CBT_DROPDOWNLIST;
   lstrcpy( combo.PropName, "TestDropDownListCombo" );
   pd.MyProps.AddStruct( &combo, sizeof( CMyPropComboStruct ) );
   
   CMyPropColorStruct color;
   color.Color = RGB( 50, 50, 50 );
   lstrcpy( color.PropName, "TextColor" );
   pd.MyProps.AddStruct( &color, sizeof( CMyPropColorStruct ) );

   CMyPropFontStruct font;
   font.FontSize = 8;
   font.isBold = 1;
   lstrcpy( font.FontName, "Arial" );
   lstrcpy( font.PropName, "TextFont" );
   pd.MyProps.AddStruct( &font, sizeof( CMyPropFontStruct ) );

   
   pd.DoModal();
}


//---------------------------------------------------------------------------------------
void CDialogEditorDlg::OnLButtonDblClk( UINT nFlags, CPoint point )
{
	CDialog::OnLButtonDblClk( nFlags, point );
/*
   CMyStruct *cms = MyDialogEditor.GetCtrlUnderPtr( point );
   if( cms != NULL )
   {
      CPropsDialog pd;

      CMyPropEditStruct editstruct;
      editstruct.struct_sign = MP_ID_EDIT;
      editstruct.isNumber = 0;
      editstruct.isEnabled = 1;
      editstruct.isFileName = 0;

      CMyPropBoolStruct boolstruct;
      boolstruct.struct_sign = MP_ID_BOOLEAN;

      // MessageBox( "Contol properties" );
      if( cms->struct_sign == WS_ID_BUTTON )
      {
         CMyButton *cmb = (CMyButton*)cms;

         lstrcpy( editstruct.EditText, cmb->text );
         lstrcpy( editstruct.PropName, "Caption" );
         pd.MyProps.AddStruct( &editstruct, sizeof( CMyPropEditStruct ) );
         
         lstrcpy( boolstruct.PropName, "Transparent" );
         boolstruct.Result = cmb->isTransparent?true:false;
         pd.MyProps.AddStruct( &boolstruct, sizeof( CMyPropBoolStruct ) );
      }
      if( cms->struct_sign == WS_ID_TEXTLABEL )
      {
         CMyTextLabel *cmtl = (CMyTextLabel*)cms;

         lstrcpy( editstruct.EditText, cmtl->text );
         lstrcpy( editstruct.PropName, "Caption" );
         pd.MyProps.AddStruct( &editstruct, sizeof( CMyPropEditStruct ) );

         lstrcpy( boolstruct.PropName, "Transparent" );
         boolstruct.Result = cmtl->isTransparent?true:false;
         pd.MyProps.AddStruct( &boolstruct, sizeof( CMyPropBoolStruct ) );
      }
      
      if( pd.DoModal() == IDOK )
      {
         // update
         if( cms->struct_sign == WS_ID_BUTTON )
         {
            CMyButton *cmb = (CMyButton*)cms;

            CMyPropEditStruct *cmpes = (CMyPropEditStruct*)pd.MyProps.GetCtrl( 0 );
            lstrcpy( cmb->text, cmpes->EditText );
         
            CMyPropBoolStruct *cmpbs = (CMyPropBoolStruct*)pd.MyProps.GetCtrl( 1 );
            cmb->isTransparent = cmpbs->Result;
         }
         if( cms->struct_sign == WS_ID_TEXTLABEL )
         {
            CMyTextLabel *cmtl = (CMyTextLabel*)cms;
            
            CMyPropEditStruct *cmpes = (CMyPropEditStruct*)pd.MyProps.GetCtrl( 0 );
            lstrcpy( cmtl->text, cmpes->EditText );
         
            CMyPropBoolStruct *cmpbs = (CMyPropBoolStruct*)pd.MyProps.GetCtrl( 1 );
            cmtl->isTransparent = cmpbs->Result;
         }
      }
   }
*/
}


//---------------------------------------------------------------------------------------
void CDialogEditorDlg::OnPaint() 
{
   CPaintDC dc( this );
   CDialog::OnPaint();
}

