#include "stdafx.h"
#include "DialogEditor.h"
#include "MyDialogEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//---------------------------------------------------------------------------------------
CMyDialogEditor::CMyDialogEditor( void )
{
   NumOfStructs = 0;
   isNeedToInvalidate = 0;
   isDragging = 0;
   isDraggingSelection = 0;
   NumOfDraggingCtrls = 0;
   isResizing = 0;
   isGrid = 1;
   GridLen = WS_DEFGRIDSIZE;
}


//---------------------------------------------------------------------------------------
CMyDialogEditor::~CMyDialogEditor( void )
{
   for( int i = 0; i < NumOfStructs; i++ ) delete []Structs_ptr[ i ];
}


//---------------------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CMyDialogEditor, CWnd)
	//{{AFX_MSG_MAP(CMyDialogEditor)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//---------------------------------------------------------------------------------------
int CMyDialogEditor::AddStruct( void *struct_ptr, int struct_len )
{
   CMyStruct *lp_cmys = (CMyStruct*)struct_ptr;
   if( lp_cmys->struct_sign != WS_ID_BUTTON &&
       lp_cmys->struct_sign != WS_ID_TEXTLABEL &&
       lp_cmys->struct_sign != WS_ID_PICTUREBOX
     )
   { 
      AfxMessageBox( "undef type" );
      return 0;
   }
   
   if( !lp_cmys->CtrlName[ 0 ] )
   {
      AfxMessageBox( "ctrl name undefined" );
      return 0;
   }

   // check for existing file name
   for( int i = 0; i < NumOfStructs; i++ )
   {
      CMyStruct *cmys = (CMyStruct*)Structs_ptr[ i ];
      if( cmys == NULL ) break;
      if( !lstrcmp( cmys->CtrlName, lp_cmys->CtrlName ) )
      {
         AfxMessageBox( "ctrl alreay exist - change name" );
         return 0;
      }
   }

   // add new
   if( NumOfStructs + 1 > WS_MAXCTRLSCOUNT ) return 0;
   Structs_ptr[ NumOfStructs ] = (void*)new UCHAR[ struct_len ];
   memcpy( Structs_ptr[ NumOfStructs ], struct_ptr, struct_len );
   RedrawCtrl( (CMyStruct*)Structs_ptr[ NumOfStructs ] );
   NumOfStructs++;
   return 1;
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::DrawBorderStuff( CDC *cdc, RECT *ctrlrect )
{
   RECT rc;
   int x, y;

   // draw framed rect around the ctrl
   
   // top
   SetRect( &rc, ctrlrect->left - 6, ctrlrect->top - 6, ctrlrect->right + 6, ctrlrect->top - 1 );
   cdc->FillSolidRect( &rc, RGB( 200, 200, 200 ) );
   for( x = rc.left; x < rc.right; x += 3 )
      for( y = rc.top + 1; y < rc.bottom - 1; y += 2, x+=2 ) cdc->SetPixel( x, y, RGB( 0, 100, 0 ) );

   // bottom
   rc.top = ctrlrect->bottom + 1;
   rc.bottom = ctrlrect->bottom + 6;
   cdc->FillSolidRect( &rc, RGB( 200, 200, 200 ) );
   for( x = rc.left; x < rc.right; x += 3 )
      for( y = rc.top + 1; y < rc.bottom - 1; y += 2, x+=2 ) cdc->SetPixel( x, y, RGB( 0, 100, 0 ) );

   // left
   rc.top = ctrlrect->top - 6;
   rc.bottom = ctrlrect->bottom + 6;
   rc.left = ctrlrect->left - 6;
   rc.right = ctrlrect->left - 1;
   cdc->FillSolidRect( &rc, RGB( 200, 200, 200 ) );
   for( y = rc.top; y < rc.bottom; y += 2 ) 
      for( x = rc.left; x < rc.right; x += 3, y += 2 )
         cdc->SetPixel( x, y, RGB( 0, 100, 0 ) );

   // right
   rc.left = ctrlrect->right + 1;
   rc.right = ctrlrect->right + 6;
   cdc->FillSolidRect( &rc, RGB( 200, 200, 200 ) );
   for( y = rc.top; y < rc.bottom; y += 2 ) 
      for( x = rc.left; x < rc.right; x += 3, y += 2 )
         cdc->SetPixel( x, y, RGB( 0, 100, 0 ) );
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::DrawSizingStuff( CDC *cdc, RECT *ctrlrect )
{
   RECT rc;
   COLORREF grn = RGB( 0, 80, 0 );

   // draw sizing stuff
   rc.left = ctrlrect->left - 6; rc.right = rc.left + 5;
   rc.top = ctrlrect->top - 6; rc.bottom = rc.top + 5;
   cdc->FillSolidRect( &rc, grn );
   rc.left = WS_Mid( ctrlrect->left, ctrlrect->right ) - 3; rc.right = rc.left + 5;
   cdc->FillSolidRect( &rc, grn );
   rc.left = ctrlrect->right + 1; rc.right = rc.left + 5;
   cdc->FillSolidRect( &rc, grn );
   rc.top = WS_Mid( ctrlrect->top, ctrlrect->bottom ) - 3; rc.bottom = rc.top + 5;
   cdc->FillSolidRect( &rc, grn );
   rc.left = ctrlrect->left - 6; rc.right = rc.left + 5;
   cdc->FillSolidRect( &rc, grn );
   rc.top = ctrlrect->bottom + 1; rc.bottom = rc.top + 5;
   cdc->FillSolidRect( &rc, grn );
   rc.left = WS_Mid( ctrlrect->left, ctrlrect->right ) - 3; rc.right = rc.left + 5;
   cdc->FillSolidRect( &rc, grn );
   rc.left = ctrlrect->right + 1; rc.right = rc.left + 5;
   cdc->FillSolidRect( &rc, grn );
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::MyPaint( CDC *cdc )
{
   RECT wnd;
   GetClientRect( &wnd );
   
   // erase all first
   cdc->FillSolidRect( &wnd, GetSysColor( COLOR_BTNFACE ) );
   
   // paint grid
   if( isGrid )
   {
      for( int x = 0; x < ( wnd.right - wnd.left ) / GridLen; x++ )
         for( int y = 0; y < ( wnd.bottom - wnd.top ) / GridLen; y++ )
            cdc->SetPixel( x * GridLen + 2, y * GridLen + 2, RGB( 50, 50, 50 ) );
   }

   cdc->SelectObject( OurFont );

   for( int i = NumOfStructs - 1; i >=0 ; i-- )
   {
      CMyStruct *lp_cmys = (CMyStruct*)Structs_ptr[ i ];
      if( lp_cmys == NULL ) break;
      
      //
      //  draw button
      //
      if( lp_cmys->struct_sign == WS_ID_BUTTON )
         DrawMyButton( (CMyButton *)Structs_ptr[ i ], cdc );

      //
      // draw label
      //
      if( lp_cmys->struct_sign == WS_ID_TEXTLABEL )
         DrawMyTextLabel( (CMyTextLabel *)Structs_ptr[ i ], cdc );

      //
      // draw picture box
      //
      if( lp_cmys->struct_sign == WS_ID_PICTUREBOX )
         DrawMyPictureBox( (CMyPictureBox *)Structs_ptr[ i ], cdc );
   }
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::MouseLButtonDown( WPARAM wParam, LPARAM lParam )
{
   POINTS pts;
   POINT pt;
   SIZE size;
   CMyStruct *lpcmys;
   char isAnySelected = 0;

   pts = MAKEPOINTS( lParam );
   pt.x = pts.x; pt.y = pts.y;
   size.cx = WS_DRAGRECTSIZE; size.cy = WS_DRAGRECTSIZE;

   // detect a ctrl under mouse ptr, select ctrls under cursor, detect select with ctrl
   // key, if no any ctrls under cursor - delselect all ctrls
   
   if( DragDetect( GetSafeHwnd(), pt ) )
CMWS_MLBD_Drag:;
      if( DragDetect( GetSafeHwnd(), pt ) )
      {
         lpcmys = GetCtrlUnderPtr( pt );
         if( lpcmys == NULL )
         {
            // selection rectangle is being dragged
            DragRect.left = pt.x;
            DragRect.top = pt.y;
            DragRect.right = DragRect.left;
            DragRect.bottom = DragRect.top;
            SetCapture();// capture mouse input
            isDragging = 1;
            isDraggingSelection = 1;
            CDC *cdc = GetDC();
            cdc->DrawDragRect( &DragRect, size, NULL, size );
            ReleaseDC( cdc );
            return;
         }
         if( !lpcmys->isSelected ) goto CMWS_MLBD_Sel;// go select one

         if( isGrid && !HIWORD( GetKeyState( VK_MENU ) ) )
         {
            pt.x = pt.x / GridLen; pt.x *= GridLen;
            pt.y = pt.y / GridLen; pt.y *= GridLen;
         }
         
         if( ResizeType != WS_RS_NONE )
         {
            // resizing detected
            ResizeCtrl = lpcmys;
            SetCapture();// capture mouse input
            SetRect( &ResizeRect, lpcmys->x, lpcmys->y, lpcmys->x + lpcmys->w, lpcmys->y + lpcmys->h );
            CDC *cdc = GetDC();
            cdc->DrawDragRect( &ResizeRect, size, NULL, size );
            ReleaseDC( cdc );
            isResizing = 1;
            return;
         }

         // lets drag some ctrls
         NumOfDraggingCtrls = 0;

         // find bound rectange for selected ctrls
         SetRect( &DragRect, lpcmys->x, lpcmys->y, lpcmys->x + lpcmys->w, lpcmys->y + lpcmys->h );
         for( int n = 0; n < NumOfStructs; n++ )
         {
            lpcmys = (CMyStruct*)Structs_ptr[ n ];
            if( !lpcmys->isSelected ) continue;
            
            if( lpcmys->x < DragRect.left ) DragRect.left = lpcmys->x;
            if( lpcmys->y < DragRect.top ) DragRect.top = lpcmys->y;
            if( lpcmys->x + lpcmys->w > DragRect.right ) DragRect.right = lpcmys->x + lpcmys->w;
            if( lpcmys->y + lpcmys->h > DragRect.bottom ) DragRect.bottom = lpcmys->y + lpcmys->h;
         }
         // cdc->FillSolidRect( &DragRect, 0 );
         MouseDragOffsetX = pt.x - DragRect.left;
         MouseDragOffsetY = pt.y - DragRect.top;

         // set up bounds offsets
         int p = 0;
         for( n = 0; n < NumOfStructs; n++ )
         {
            lpcmys = (CMyStruct*)Structs_ptr[ n ];
            if( !lpcmys->isSelected ) continue;
            
            DragStructs[ p ].DragCtrl = lpcmys;
            DragStructs[ p ].BoundOffsetX = lpcmys->x - DragRect.left;
            DragStructs[ p ].BoundOffsetY = lpcmys->y - DragRect.top;
            RECT rr;
            SetRect( &rr, 
                     DragRect.left + DragStructs[ p ].BoundOffsetX,
                     DragRect.top + DragStructs[ p ].BoundOffsetY,
                     DragRect.left + DragStructs[ p ].DragCtrl->w + DragStructs[ p ].BoundOffsetX,
                     DragRect.top + DragStructs[ p ].DragCtrl->h + DragStructs[ p ].BoundOffsetY );
            CDC *cdc = GetDC();
            cdc->DrawDragRect( &rr, size, NULL, size );
            ReleaseDC( cdc );
            p++;
         }
         NumOfDraggingCtrls = p;
         /*char ts[ 200 ];wsprintf( ts, "num=%i", p );AfxMessageBox( ts );*/
         isDragging = 1;
         SetCapture();// capture mouse input
         return;
      }

CMWS_MLBD_Sel:;
   if( isAnySelected ) return;
   CMyStruct *lp_cmys = GetCtrlUnderPtr( pt );
   if( lp_cmys != NULL )
   {
      if( wParam & MK_SHIFT )
      {
         lp_cmys->isSelected = !lp_cmys->isSelected;// invert selection
      }else{
         DeselectAll();
         lp_cmys->isSelected = 1;
      }
      isAnySelected = 1;
      RedrawCtrl( lp_cmys, true );
   }
   if( !isAnySelected && !( wParam & MK_SHIFT ) )
   {
      // deselect all because click is out of any ctrl
      DeselectAll();
   }

   if( DragDetect( GetSafeHwnd(), pt ) ) goto CMWS_MLBD_Drag;
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::MouseLButtonUp( WPARAM wParam, LPARAM lParam )
{
   POINTS pts;
   POINT pt;

   pts = MAKEPOINTS( lParam );
   pt.x = pts.x; pt.y = pts.y;
   
   if( isResizing )
   {
      CMyStruct oldResizeCtrl;
      memcpy( &oldResizeCtrl, ResizeCtrl, sizeof( CMyStruct ) );
      // resize is done
      ResizeCtrl->x = ResizeRect.left;
      ResizeCtrl->y = ResizeRect.top;
      ResizeCtrl->w = ResizeRect.right - ResizeRect.left;
      ResizeCtrl->h = ResizeRect.bottom - ResizeRect.top;

      isResizing = 0;
      ReleaseCapture();// free mouse input
      // fix cursor
      MouseMove( wParam, lParam );
      // invalidate
      RedrawCtrl( &oldResizeCtrl );// erase old
      RedrawCtrl( ResizeCtrl );// draw new
      return;
   }
   
   if( isDragging )
   {
      if( isDraggingSelection )
      {
         // select ctrls under selection rectangle
         isDragging = 0;
         isDraggingSelection = 0;
         ReleaseCapture();// free mouse input
         if( !(wParam & MK_SHIFT ) ) DeselectAll();
         SelectCtrlsUnderSelRect();
         return;
      }

      isDragging = 0;
      
      // AfxMessageBox( "DragEnd" );
      for( int n = 0; n < NumOfDraggingCtrls; n++ )
      {
         CMyStruct oldCtrl;
         memcpy( &oldCtrl, DragStructs[ n ].DragCtrl, sizeof( CMyStruct ) );

         RECT rr;
         SetRect( &rr,
                  DragRect.left + DragStructs[ n ].BoundOffsetX,
                  DragRect.top + DragStructs[ n ].BoundOffsetY,
                  DragRect.left + DragStructs[ n ].DragCtrl->w + DragStructs[ n ].BoundOffsetX,
                  DragRect.top + DragStructs[ n ].DragCtrl->h + DragStructs[ n ].BoundOffsetY 
                );
         
         DragStructs[ n ].DragCtrl->x = rr.left;
         DragStructs[ n ].DragCtrl->y = rr.top;

         RedrawCtrl( &oldCtrl );// erase old
         RedrawCtrl( DragStructs[ n ].DragCtrl );// draw new
      }
      
      ReleaseCapture();// free mouse input
      return;
   }

}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::MouseMove( WPARAM wParam, LPARAM lParam )
{
   POINTS pts;
   POINT pt;
   SIZE size;

   pts = MAKEPOINTS( lParam );
   pt.x = pts.x; pt.y = pts.y;
   size.cx = WS_DRAGRECTSIZE; size.cy = WS_DRAGRECTSIZE;

   
   if( isResizing )
   {
      RECT sr;
      CopyRect( &sr, &ResizeRect );

      if( isGrid && !HIWORD( GetKeyState( VK_MENU ) ) )
      {
         pt.x = pt.x /= GridLen; pt.x *= GridLen;
         pt.y = pt.y /= GridLen; pt.y *= GridLen;
      }

      SetResizeRectangle( pt );
      // draw resizing rectangle
      CDC *cdc = GetDC();
      cdc->DrawDragRect( &ResizeRect, size, &sr, size );
      ReleaseDC( cdc );
      return;
   }
   
   
   if( isDragging )
   {
      if( isGrid && !HIWORD( GetKeyState( VK_MENU ) ) )
      {
         pt.x = pt.x / GridLen; pt.x *= GridLen;
         pt.y = pt.y / GridLen; pt.y *= GridLen;
      }

      RECT dr;
      CopyRect( &dr, &DragRect );
      if( isDraggingSelection )
      {
         // draw selection rectangle
         DrawSelRect( &DragRect, pt );
         return;
      }
      
      int dw = DragRect.right - DragRect.left;
      int dh = DragRect.bottom - DragRect.top;
      RECT DragRectO;
      CopyRect( &DragRectO, &DragRect );

      DragRect.left = pt.x - MouseDragOffsetX;
      DragRect.top = pt.y - MouseDragOffsetY;
      DragRect.right = DragRect.left + dw;
      DragRect.bottom = DragRect.top + dh;
      //cdc->FillSolidRect( &DragRect, 0 );
      CheckUpDragRect( &DragRect );

      // draw drag rectangle for dragging ctrls
      for( int n = 0; n < NumOfDraggingCtrls; n++ )
      {
         SetRect( &dr,
                  DragRectO.left + DragStructs[ n ].BoundOffsetX,
                  DragRectO.top + DragStructs[ n ].BoundOffsetY,
                  DragRectO.left + DragStructs[ n ].DragCtrl->w + DragStructs[ n ].BoundOffsetX,
                  DragRectO.top + DragStructs[ n ].DragCtrl->h + DragStructs[ n ].BoundOffsetY 
                );
         // set new pos
         RECT rr;
         SetRect( &rr,
                  DragRect.left + DragStructs[ n ].BoundOffsetX,
                  DragRect.top + DragStructs[ n ].BoundOffsetY,
                  DragRect.left + DragStructs[ n ].DragCtrl->w + DragStructs[ n ].BoundOffsetX,
                  DragRect.top + DragStructs[ n ].DragCtrl->h + DragStructs[ n ].BoundOffsetY 
                );
         CDC *cdc = GetDC();
         cdc->DrawDragRect( &rr, size, &dr, size );
         ReleaseDC( cdc );
      }

      return;
   }

   // change cursor
   HCURSOR hcur = GetCursor();
   CMyStruct *lp_cmys = GetCtrlUnderPtr( pt );
   if( lp_cmys != NULL )
   {
      if( lp_cmys->isSelected && !isResizing )
      {
         ResizeType = WS_RS_NONE;
         RECT rc;
         RECT c_rc;
         SetRect( &c_rc, lp_cmys->x, lp_cmys->y, lp_cmys->x + lp_cmys->w, lp_cmys->y + lp_cmys->h );
         // change size cursor
         rc.left = c_rc.left - 6; rc.right = rc.left + 5;
         rc.top = c_rc.top - 6; rc.bottom = rc.top + 5;
         if( PtInRect( &rc, pt ) ) ResizeType = WS_RS_LEFTTOP;
         rc.left = WS_Mid( c_rc.left, c_rc.right ) - 3; rc.right = rc.left + 5;
         if( PtInRect( &rc, pt ) ) ResizeType = WS_RS_CENTERTOP;
         rc.left = c_rc.right + 1; rc.right = rc.left + 5;
         if( PtInRect( &rc, pt ) ) ResizeType = WS_RS_RIGHTTOP;
         rc.top = WS_Mid( c_rc.top, c_rc.bottom ) - 3; rc.bottom = rc.top + 5;
         if( PtInRect( &rc, pt ) ) ResizeType = WS_RS_RIGHTCENTER;
         rc.left = c_rc.left - 6; rc.right = rc.left + 5;
         if( PtInRect( &rc, pt ) ) ResizeType = WS_RS_LEFTCENTER;
         rc.top = c_rc.bottom + 1; rc.bottom = rc.top + 5;
         if( PtInRect( &rc, pt ) ) ResizeType = WS_RS_LEFTBOTTOM;
         rc.left = WS_Mid( c_rc.left, c_rc.right ) - 3; rc.right = rc.left + 5;
         if( PtInRect( &rc, pt ) ) ResizeType = WS_RS_CENTERBOTTOM;
         rc.left = c_rc.right + 1; rc.right = rc.left + 5;
         if( PtInRect( &rc, pt ) ) ResizeType = WS_RS_RIGHTBOTTOM;
         switch( ResizeType )
         {
            case WS_RS_LEFTTOP:
            case WS_RS_RIGHTBOTTOM:
               SetCursor( LoadCursor( NULL, IDC_SIZENWSE ) );
               break;
            case WS_RS_CENTERTOP:
            case WS_RS_CENTERBOTTOM:
               SetCursor( LoadCursor( NULL, IDC_SIZENS ) );
               break;
            case WS_RS_LEFTCENTER:
            case WS_RS_RIGHTCENTER:
               SetCursor( LoadCursor( NULL, IDC_SIZEWE ) );
               break;
            case WS_RS_LEFTBOTTOM:
            case WS_RS_RIGHTTOP:
               SetCursor( LoadCursor( NULL, IDC_SIZENESW ) );
               break;
            case WS_RS_NONE:
               SetCursor( LoadCursor( NULL, IDC_SIZEALL ) );
               break;
         }
      }
   }else{
      if( !isResizing && !isDragging )
         SetCursor( LoadCursor( NULL, IDC_ARROW ) );// normal arrow
   }

   //AfxMessageBox( "lbtndown" );
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::MouseRButtonDown( WPARAM wParam, LPARAM lParam )
{
   int  t;
   SIZE size;
   size.cx = WS_DRAGRECTSIZE; size.cy = WS_DRAGRECTSIZE;

   if( isDragging && isDraggingSelection )
   {
      RECT dragrc;
      CopyRect( &dragrc, &DragRect );
      if( dragrc.left > dragrc.right ){ t = dragrc.left; dragrc.left = dragrc.right; dragrc.right = t; }
      if( dragrc.top > dragrc.bottom ){ t = dragrc.top; dragrc.top = dragrc.bottom; dragrc.bottom = t; }
      // cancel selection
      isDragging = 0;
      isDraggingSelection = 0;
      ReleaseCapture();// free mouse input
      CDC *cdc = GetDC();
      cdc->DrawDragRect( &dragrc, size, NULL, size );// erase sel rect
      ReleaseDC( cdc );
      return;
   }
   if( isDragging )
   {
      // cancel drag
      isDragging = 0;
      ReleaseCapture();// free mouse input
      // erase drag rectangle for dragging ctrls
      for( int n = 0; n < NumOfDraggingCtrls; n++ )
      {
         RECT rr;
         SetRect( &rr,
                  DragRect.left + DragStructs[ n ].BoundOffsetX,
                  DragRect.top + DragStructs[ n ].BoundOffsetY,
                  DragRect.left + DragStructs[ n ].DragCtrl->w + DragStructs[ n ].BoundOffsetX,
                  DragRect.top + DragStructs[ n ].DragCtrl->h + DragStructs[ n ].BoundOffsetY 
                );
         CDC *cdc = GetDC();
         cdc->DrawDragRect( &rr, size, NULL, size );
         ReleaseDC( cdc );
      }
      return;
   }
   if( isResizing )
   {
      // cancel resize
      isResizing = 0;
      ReleaseCapture();// free mouse input
      // fix cursor
      MouseMove( wParam, lParam );
      CDC *cdc = GetDC();
      cdc->DrawDragRect( &ResizeRect, size, NULL, size );// erase stuff
      ReleaseDC( cdc );
      return;
   }
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::DeselectAll( void )
{
   for( int i = 0; i < NumOfStructs; i++ )
   {
      CMyStruct *lp_cmys = (CMyStruct*)Structs_ptr[ i ];
      if( !lp_cmys->isSelected ) continue;
      lp_cmys->isSelected = 0;
      // redraw ctrls
      RedrawCtrl( lp_cmys, true );
   }
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::InvalidateIfNeeded( void )
{
   if( isNeedToInvalidate )
   {
      //ASSERT( cwnd );
      Invalidate();
      isNeedToInvalidate = 0;
   }
}


//---------------------------------------------------------------------------------------
int CMyDialogEditor::GetSelectedCount( void )
{
   int ret = 0;
   for( int i = 0; i < NumOfStructs; i++ )
      if( ((CMyStruct *)Structs_ptr[ i ])->isSelected ) ret++;
   return ret;
}


//---------------------------------------------------------------------------------------
CMyStruct *CMyDialogEditor::GetCtrlUnderPtr( POINT pt )
{
   RECT c_rc;
   for( int i = 0; i < NumOfStructs; i++ )
   {
      CMyStruct *lp_cmys = (CMyStruct*)Structs_ptr[ i ];
      if( !lp_cmys->isSelected )
         SetRect( &c_rc, lp_cmys->x, lp_cmys->y, lp_cmys->x + lp_cmys->w, lp_cmys->y + lp_cmys->h );
      else
         SetRect( &c_rc, lp_cmys->x - 6, lp_cmys->y - 6, lp_cmys->x + lp_cmys->w + 6, lp_cmys->y + lp_cmys->h + 6 );
      if( PtInRect( &c_rc, pt ) ) return lp_cmys;
   }
   return NULL;
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::CheckUpDragRect( LPRECT rc )
{
   RECT wnd;
   GetClientRect( &wnd );
   InflateRect( &wnd, -2, -2 );
   int w = rc->right - rc->left;
   int h = rc->bottom - rc->top;
   if( rc->left < wnd.left ){ rc->left = wnd.left; rc->right = rc->left + w; }
   if( rc->top < wnd.top ){ rc->top = wnd.top; rc->bottom = rc->top + h; }
   if( rc->right > wnd.right ){ rc->left = wnd.right - w; rc->right = rc->left + w; }
   if( rc->bottom > wnd.bottom ){ rc->top = wnd.bottom - h; rc->bottom = rc->top + h; }
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::DrawSelRect( LPRECT rc, POINT mouse )
{
   int t;

   SIZE size;
   size.cx = WS_DRAGRECTSIZE; size.cy = WS_DRAGRECTSIZE;

   RECT wnd;
   GetClientRect( &wnd );
   InflateRect( &wnd, -2, -2 );
   
   RECT dp, rect;
   CopyRect( &dp, rc );
   rc->right = mouse.x;
   rc->bottom = mouse.y;
   CopyRect( &rect, rc );

   if( rect.left > rect.right ){ t = rect.left; rect.left = rect.right; rect.right = t; }
   if( rect.top > rect.bottom ){ t = rect.top; rect.top = rect.bottom; rect.bottom = t; }

   if( dp.left > dp.right ){ t = dp.left; dp.left = dp.right; dp.right = t; }
   if( dp.top > dp.bottom ){ t = dp.top; dp.top = dp.bottom; dp.bottom = t; }

   if( rect.left < wnd.left ) rect.left = wnd.left;
   if( rect.right > wnd.right ) rect.right = wnd.right;
   if( rect.top < wnd.top ) rect.top = wnd.top;
   if( rect.bottom > wnd.bottom ) rect.bottom = wnd.bottom;

   if( dp.left < wnd.left ) dp.left = wnd.left;
   if( dp.right > wnd.right ) dp.right = wnd.right;
   if( dp.top < wnd.top ) dp.top = wnd.top;
   if( dp.bottom > wnd.bottom ) dp.bottom = wnd.bottom;

   CDC *cdc = GetDC();
   cdc->DrawDragRect( &rect, size, &dp, size );
   ReleaseDC( cdc );
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::SelectCtrlsUnderSelRect( void )
{
   RECT ctrlrc;
   RECT dragrc;
   RECT dummy;
   int  t;
   SIZE size;

   size.cx = WS_DRAGRECTSIZE; size.cy = WS_DRAGRECTSIZE;
   CopyRect( &dragrc, &DragRect );
   if( dragrc.left > dragrc.right ){ t = dragrc.left; dragrc.left = dragrc.right; dragrc.right = t; }
   if( dragrc.top > dragrc.bottom ){ t = dragrc.top; dragrc.top = dragrc.bottom; dragrc.bottom = t; }

   RECT wnd;
   GetClientRect( &wnd );
   InflateRect( &wnd, -2, -2 );
   if( dragrc.left < wnd.left ) dragrc.left = wnd.left;
   if( dragrc.right > wnd.right ) dragrc.right = wnd.right;
   if( dragrc.top < wnd.top ) dragrc.top = wnd.top;
   if( dragrc.bottom > wnd.bottom ) dragrc.bottom = wnd.bottom;

   for( int i = 0; i < NumOfStructs; i++ )
   {
      CMyStruct *lp_cmys = (CMyStruct*)Structs_ptr[ i ];
      SetRect( &ctrlrc, lp_cmys->x, lp_cmys->y, lp_cmys->x + lp_cmys->w, lp_cmys->y + lp_cmys->h );
      if( IntersectRect( &dummy, &dragrc, &ctrlrc ) && EqualRect( &dummy, &ctrlrc ) )
         lp_cmys->isSelected = 1;
   }
   // redraw ctrls
   for( i = 0; i < NumOfStructs; i++ )
   {
      CMyStruct *lp_cmys = (CMyStruct*)Structs_ptr[ i ];
      SetRect( &ctrlrc, lp_cmys->x, lp_cmys->y, lp_cmys->x + lp_cmys->w, lp_cmys->y + lp_cmys->h );
      if( IntersectRect( &dummy, &dragrc, &ctrlrc ) && EqualRect( &dummy, &ctrlrc ) )
         if( lp_cmys->isSelected ) 
            RedrawCtrl( lp_cmys, true );
   }
   CDC *cdc = GetDC();
   cdc->DrawDragRect( &dragrc, size, NULL, size );// erase sel rect
   ReleaseDC( cdc );
}


//---------------------------------------------------------------------------------------
// Need to draw and check resizing rectangle
//
void CMyDialogEditor::SetResizeRectangle( POINT pt )
{
   // change
   switch( ResizeType )
   {
      case WS_RS_RIGHTTOP:
         ResizeRect.right = pt.x;
         ResizeRect.top = pt.y;
         if( ResizeRect.right - ResizeRect.left < 10 ) ResizeRect.right = ResizeRect.left + 10;
         if( ResizeRect.bottom - ResizeRect.top < 10 ) ResizeRect.top = ResizeRect.bottom - 10;
         break;
      case WS_RS_RIGHTCENTER:
         ResizeRect.right = pt.x;
         if( ResizeRect.right - ResizeRect.left < 10 ) ResizeRect.right = ResizeRect.left + 10;
         break;
      case WS_RS_RIGHTBOTTOM:
         ResizeRect.right = pt.x;
         ResizeRect.bottom = pt.y;
         if( ResizeRect.right - ResizeRect.left < 10 ) ResizeRect.right = ResizeRect.left + 10;
         if( ResizeRect.bottom - ResizeRect.top < 10 ) ResizeRect.bottom = ResizeRect.top + 10;
         break;
      case WS_RS_CENTERTOP:
         ResizeRect.top = pt.y;
         if( ResizeRect.bottom - ResizeRect.top < 10 ) ResizeRect.top = ResizeRect.bottom - 10;
         break;
      case WS_RS_CENTERBOTTOM:
         ResizeRect.bottom = pt.y;
         if( ResizeRect.bottom - ResizeRect.top < 10 ) ResizeRect.bottom = ResizeRect.top + 10;
         break;
      case WS_RS_LEFTTOP:
         ResizeRect.left = pt.x;
         ResizeRect.top = pt.y;
         if( ResizeRect.right - ResizeRect.left < 10 ) ResizeRect.left = ResizeRect.right - 10;
         if( ResizeRect.bottom - ResizeRect.top < 10 ) ResizeRect.top = ResizeRect.bottom - 10;
         break;
      case WS_RS_LEFTCENTER:
         ResizeRect.left = pt.x;
         if( ResizeRect.right - ResizeRect.left < 10 ) ResizeRect.left = ResizeRect.right - 10;
         break;
      case WS_RS_LEFTBOTTOM:
         ResizeRect.left = pt.x;
         ResizeRect.bottom = pt.y;
         if( ResizeRect.right - ResizeRect.left < 10 ) ResizeRect.left = ResizeRect.right - 10;
         if( ResizeRect.bottom - ResizeRect.top < 10 ) ResizeRect.bottom = ResizeRect.top + 10;
         break;
   };
   // check
   RECT wnd;
   GetClientRect( &wnd );
   InflateRect( &wnd, -2, -2 );

   if( ResizeRect.right > wnd.right ) ResizeRect.right = wnd.right;
   if( ResizeRect.top < wnd.top ) ResizeRect.top = wnd.top;
   if( ResizeRect.left < wnd.left ) ResizeRect.left = wnd.left;
   if( ResizeRect.bottom > wnd.bottom ) ResizeRect.bottom = wnd.bottom;
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::RedrawCtrl( CMyStruct *lp_cmys, bool redrawselonly )
{
   RECT rc;
   if( !redrawselonly )
   {
      SetRect( &rc, lp_cmys->x - 6, lp_cmys->y - 6, lp_cmys->x + lp_cmys->w + 6, lp_cmys->y + lp_cmys->h + 6 );
      InvalidateRect( &rc );
   }else{
      RECT ctrl;
      SetRect( &ctrl, lp_cmys->x, lp_cmys->y, lp_cmys->x + lp_cmys->w, lp_cmys->y + lp_cmys->h );

      SetRect( &rc, ctrl.left - 6, ctrl.top - 6, ctrl.right + 6, ctrl.top - 1 );
      InvalidateRect( &rc );

      rc.top = ctrl.bottom + 6;
      rc.bottom = ctrl.bottom + 1;
      InvalidateRect( &rc );

      rc.top = ctrl.top - 6;
      rc.bottom = ctrl.bottom + 6;
      rc.left = ctrl.left - 6;
      rc.right = ctrl.left - 1;
      InvalidateRect( &rc );

      rc.left = ctrl.right + 1;
      rc.right = ctrl.right + 6;
      InvalidateRect( &rc );
   }
}



//---------------------------------------------------------------------------------------
LRESULT CMyDialogEditor::WindowProc( UINT message, WPARAM wParam, LPARAM lParam )
{
   switch( message )
   {
      case WM_CREATE:
         // setup fonts
         LOGFONT lf;
         memset( &lf, 0, sizeof( LOGFONT ) );
         lf.lfHeight = 14;
         lf.lfWeight = FW_NORMAL;
         strcpy( lf.lfFaceName, "Arial" );
         OurFont.CreateFontIndirect( &lf );
         SetFont( &OurFont );
         SetRedraw();
         break;

      case WM_MOUSEMOVE:
         MouseMove( wParam, lParam );
         break;

      case WM_LBUTTONDOWN:
         MouseLButtonDown( wParam, lParam );
         break;

      case WM_LBUTTONUP:
         MouseLButtonUp( wParam, lParam );
         break;

      case WM_RBUTTONDOWN:
         MouseRButtonDown( wParam, lParam );
         break;

      case WM_SETCURSOR:
/*         POINT pt;
         RECT wrc;
         GetCursorPos( &pt );
         GetWindowRect( &wrc );
         if( PtInRect( &wrc, pt ) ) return false;// use to kick cursor flickering
*/         break;

   }
   
   return CWnd::WindowProc( message, wParam, lParam );
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::OnPaint() 
{
	CPaintDC dc( this );
   MyPaint( &dc );
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::DrawMyButton( CMyButton *btn, CDC *cdc )
{
/* 
   char   prop_Caption[ MAX_PATH ];
   char   prop_Transparent;
   char   prop_Visible;
   char   prop_Disabled;
   char   prop_Default;
   char   prop_Multiline;
   long   prop_HorAlign;
   long   prop_VertAlign;
*/
   RECT rc, trc;
   SetRect( &rc, btn->x, btn->y, btn->x + btn->w, btn->y + btn->h );
   CopyRect( &trc, &rc );
   InflateRect( &trc, -4, -4 );

   // draw text
   if( btn->prop_Transparent ) 
   {
      cdc->SetBkMode( TRANSPARENT );
   }else{
      cdc->SetBkMode( OPAQUE );
      cdc->FillSolidRect( &rc, GetSysColor( COLOR_BTNFACE ) );
   }
   cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
   cdc->SetBkColor( GetSysColor( COLOR_BTNFACE ) );

   // set up the font
   cdc->SelectObject( GetFont() );

   // set up text format
   UINT nFormat = 0;
   if( btn->prop_Multiline ) nFormat |= DT_WORDBREAK;
   switch( btn->prop_HorAlign )
   {
      case BS_CENTER: nFormat |= DT_CENTER; break;
      case BS_LEFT: nFormat |= DT_LEFT; break;
      case BS_RIGHT: nFormat |= DT_RIGHT; break;
   }
   switch( btn->prop_VertAlign )
   {
      case BS_VCENTER: nFormat |= DT_VCENTER; break;
      case BS_TOP: nFormat |= DT_TOP; break;
      case BS_BOTTOM: nFormat |= DT_BOTTOM; break;
   }
   if( btn->prop_Multiline && btn->prop_VertAlign == BS_VCENTER )
   {
      // resetup trc rect to emulate vert center (DrawText not support multiline with vert center)
      int linescount = 0;
      for( int i = 0; i < lstrlen( btn->prop_Caption ); i++ )
         if( btn->prop_Caption[ i ] == '\n' ) linescount++;
      if( linescount ) linescount++;
      
      int TextHeight = 14;
      linescount *= TextHeight;
      trc.top += ( ( trc.bottom - trc.top ) / 2 - linescount / 2 );
      
      // draw multiline with BS_VCENTER
      char word[ 100 ]; 
      int p = 0;
      for( i = 0; i <= lstrlen( btn->prop_Caption ); i++ )
      {
         word[ p ] = btn->prop_Caption[ i ];
         if( word[ p ] && word[ p ] != '\n' ){ p++; continue; }
         word[ p ] = 0;
         if( word[ p + 1 ] == 0x0A ) i++;
         p = 0;
         // MessageBox( word );
         // draw word
         if( btn->prop_Disabled )
            DrawDisabledText( cdc, word, &trc, nFormat );
         else
            cdc->DrawText( word, lstrlen( word ), &trc, nFormat );
         trc.top += TextHeight;
      }
   }else{
      // draw normal
      if( btn->prop_Disabled )
         DrawDisabledText( cdc, btn->prop_Caption, &trc, nFormat );
      else
         cdc->DrawText( btn->prop_Caption, lstrlen( btn->prop_Caption ), &trc, nFormat );//DT_CENTER | DT_SINGLELINE | DT_VCENTER );
   }

   // draw frame
   cdc->DrawEdge( &rc, EDGE_RAISED, BF_RECT );
   if( btn->prop_Default )
   {
      // draw def btn
      cdc->Draw3dRect( btn->x + 2, btn->y + 2, btn->w - 3, btn->h - 3, GetSysColor( COLOR_BTNFACE ), GetSysColor( COLOR_3DDKSHADOW ) );
      cdc->Draw3dRect( btn->x + 3, btn->y + 3, btn->w - 4, btn->h - 4, GetSysColor( COLOR_BTNFACE ), GetSysColor( COLOR_3DDKSHADOW ) );
   }

   if( btn->isSelected )
   {
      // draw controls about a button (sizing stuff)
      SetRect( &rc, btn->x, btn->y, btn->x + btn->w, btn->y + btn->h );
      DrawBorderStuff( cdc, &rc );
      DrawSizingStuff( cdc, &rc );
   }
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::DrawMyTextLabel( CMyTextLabel *tlab, CDC *cdc )
{
/*
   char   prop_Caption[ MAX_PATH ];
   char   prop_Transparent;
   char   prop_Visible;
   char   prop_Disabled;
   char   prop_CenterVertically;
   char   prop_NoPrefix;
   char   prop_NoWrap;
   char   prop_Simple;
   long   prop_AlignText;
*/
   RECT rc; 
   SetRect( &rc, tlab->x, tlab->y, tlab->x + tlab->w, tlab->y + tlab->h );

   // draw text
   if( tlab->prop_Transparent ) 
   {
      cdc->SetBkMode( TRANSPARENT );
   }else{
      cdc->SetBkMode( OPAQUE );
      cdc->FillSolidRect( &rc, GetSysColor( COLOR_BTNFACE ) );
   }
   cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
   cdc->SetBkColor( GetSysColor( COLOR_BTNFACE ) );

   // set up text format
   UINT Style = 0;
   if( tlab->prop_Simple ) Style |= DT_SINGLELINE;
   if( tlab->prop_NoWrap ) Style |= SS_LEFTNOWORDWRAP;
   UINT nFormat = ( ( Style & SS_LEFTNOWORDWRAP ) == SS_LEFTNOWORDWRAP ? DT_SINGLELINE : DT_WORDBREAK ) | 
                    ( tlab->prop_AlignText == SS_LEFT ? DT_LEFT : ( tlab->prop_AlignText == SS_RIGHT ? DT_RIGHT : DT_CENTER ) );
   if( tlab->prop_CenterVertically ) nFormat |= DT_VCENTER;
   if( tlab->prop_NoPrefix ) nFormat |= DT_NOPREFIX;
   // set up the font
   cdc->SelectObject( GetFont() );
   
   if( tlab->prop_Disabled )
      DrawDisabledText( cdc, tlab->prop_Caption, &rc, nFormat );
   else
      cdc->DrawText( tlab->prop_Caption, lstrlen( tlab->prop_Caption ), &rc, nFormat );

   if( tlab->prop_Border )
      cdc->DrawEdge( &rc, EDGE_ETCHED, BF_RECT );

   if( tlab->isSelected )
   {
      // draw controls about a button (sizing stuff)
      DrawBorderStuff( cdc, &rc );
      DrawSizingStuff( cdc, &rc );
   }
}


//------------------------------------------------------------------------
void ShowMeLastError( DWORD lasterr )
{
   LPVOID lpMsgBuf;
 
   FormatMessage( 
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
      NULL,
      lasterr,
      MAKELANGID( LANG_NEUTRAL, SUBLANG_DEFAULT ), // Default language
      (LPTSTR) &lpMsgBuf,
      0,
      NULL 
   );

   // Display the string.
   MessageBox( GetFocus(), (char*)lpMsgBuf, "GetLastError", MB_OK | MB_ICONINFORMATION );
 
   // Free the buffer.
   LocalFree( lpMsgBuf );
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::DrawMyPictureBox( CMyPictureBox *pb, CDC *cdc )
{
   RECT rc; 
   SetRect( &rc, pb->x, pb->y, pb->x + pb->w, pb->y + pb->h );
   RECT wrc; 
   GetClientRect( &wrc );

   
   cdc->FillSolidRect( &rc, GetSysColor( COLOR_BTNFACE ) );

   if( pb->Image == NULL )
      LoadOurBitmapIntoMyPictureBox( pb );
   
   if( pb->Image != NULL )
      if( !pb->prop_Tile )
      {
         cdc->DrawState( CPoint( pb->x, pb->y ), CSize( pb->w, pb->h ), pb->Image, DST_BITMAP | DSS_NORMAL );
      }else{
         int xc, yc;
         xc = pb->w / ( pb->ImageWidth + 1 );
         yc = pb->h / ( pb->ImageHeight + 1 );
         for( int x = 0; x <= xc; x++ )
            for( int y = 0; y <= yc; y++ )
            {
               int xx = pb->x + x * pb->ImageWidth;
               int yy = pb->y + y * pb->ImageHeight;
               int ww = pb->w;
               int hh = pb->h;
               if( xx + ww > rc.right ) ww = rc.right - xx;
               if( yy + hh > rc.bottom ) hh = rc.bottom - yy;
               cdc->DrawState( CPoint( xx, yy ), CSize( ww, hh ), pb->Image, DST_BITMAP | DSS_NORMAL );
            }
      }
   
   if( pb->prop_Border )
      cdc->Draw3dRect( pb->x, pb->y, pb->w, pb->h, GetSysColor( COLOR_3DHILIGHT ), GetSysColor( COLOR_3DDKSHADOW ) );
   
   if( pb->isSelected )
   {
      // draw controls about a button (sizing stuff)
      DrawBorderStuff( cdc, &rc );
      DrawSizingStuff( cdc, &rc );
   }
}


//---------------------------------------------------------------------------------------
void CMyDialogEditor::DrawDisabledText( CDC *cdc, char *text, RECT *rc, UINT nFormat )
{
   COLORREF sav = cdc->GetTextColor();
   RECT dw; CopyRect( &dw, rc );
   int savbk = cdc->GetBkMode();

   cdc->SetBkMode( TRANSPARENT );
   cdc->SetTextColor( GetSysColor( COLOR_HIGHLIGHTTEXT ) );
   dw.left+=2; dw.top+=1;
   cdc->DrawText( text, lstrlen( text ), &dw, nFormat );
   dw.left-=2; dw.top-=1;
   cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
   cdc->DrawText( text, lstrlen( text ), &dw, nFormat );

   cdc->SetTextColor( sav );
   cdc->SetBkMode( savbk );
}


//---------------------------------------------------------------------------------------
int CMyDialogEditor::LoadOurBitmapIntoMyPictureBox( CMyPictureBox *cmpb )
{
   ASSERT( cmpb );
   if( !cmpb->prop_FileName[ 0 ] ) return 0;
   if( cmpb->Image != NULL ) DeleteObject( cmpb->Image );
   cmpb->Image = (HBITMAP)LoadImage( GetModuleHandle( NULL ), cmpb->prop_FileName,
                                      IMAGE_BITMAP, 0, 0,
                                      LR_LOADFROMFILE |
                                      LR_CREATEDIBSECTION );
   if( cmpb->Image == NULL ) return 0;

   BITMAP bm;
   GetObject( cmpb->Image, sizeof( bm ), (LPSTR)&bm );
   cmpb->ImageWidth = bm.bmWidth;
   cmpb->ImageHeight = bm.bmHeight;

   return 1;
};


