#if !defined(AFX_MYDIALOGEDITOR_H__81E7691F_D70D_436C_9330_975B4308FF46__INCLUDED_)
#define AFX_MYDIALOGEDITOR_H__81E7691F_D70D_436C_9330_975B4308FF46__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif


//---------------------------------------------------------------------------------------
#define WS_Mid(a,b) (a+b)/2


//---------------------------------------------------------------------------------------
#define WS_DRAGRECTSIZE      3

#define WS_ID_EMPTY          0
#define WS_ID_BUTTON         1000
#define WS_ID_TEXTLABEL      1001
#define WS_ID_PICTUREBOX     1002

#define WS_MAXSELECTEDCTRLS  300
#define WS_MAXCTRLSCOUNT     300
#define WS_RS_NONE           0
#define WS_RS_LEFTTOP        1
#define WS_RS_LEFTCENTER     2
#define WS_RS_LEFTBOTTOM     3
#define WS_RS_CENTERTOP      4
#define WS_RS_CENTERBOTTOM   5
#define WS_RS_RIGHTTOP       6
#define WS_RS_RIGHTCENTER    7
#define WS_RS_RIGHTBOTTOM    8
#define WS_DEFGRIDSIZE       10


//---------------------------------------------------------------------------------------
struct CMyStruct
{
   UINT struct_sign;
   
   // std members
   int    x, y;
   int    w, h;
   char   isSelected;
   char   CtrlName[ 64 ];
};


//---------------------------------------------------------------------------------------
struct CMyButton
{
   UINT   struct_sign;
   
   // std members
   int    x, y;
   int    w, h;
   char   isSelected;
   char   CtrlName[ 64 ];
   
   // speciefic members
   char   prop_Caption[ MAX_PATH ];
   char   prop_Transparent;
   char   prop_Visible;
   char   prop_Disabled;
   char   prop_Default;
   char   prop_Multiline;
   long   prop_HorAlign;
   long   prop_VertAlign;

   // contructor & destructor
   CMyButton( void ){ struct_sign = WS_ID_BUTTON; x = 0; y = 0; w = 0; h = 0; isSelected = 0;  CtrlName[ 0 ] = 0;
                      prop_Transparent = 0; prop_Caption[ 0 ] = 0; prop_Visible = 1;
                      prop_Disabled = 0; prop_Default = 0; prop_Multiline = 0;
                      prop_HorAlign = BS_CENTER; prop_VertAlign = BS_VCENTER;
   };
   ~CMyButton( void ){};
};


//---------------------------------------------------------------------------------------
struct CMyTextLabel
{
   UINT   struct_sign;
   
   // std members
   int    x, y;
   int    w, h;
   char   isSelected;
   char   CtrlName[ 64 ];
   
   // speciefic members
   char   prop_Caption[ MAX_PATH ];
   char   prop_Transparent;
   char   prop_Visible;
   char   prop_Disabled;
   char   prop_CenterVertically;
   char   prop_NoPrefix;
   char   prop_NoWrap;
   char   prop_Simple;
   long   prop_AlignText;
   char   prop_Border;

   // contructor & destructor
   CMyTextLabel( void ){ struct_sign = WS_ID_TEXTLABEL; x = 0; y = 0; w = 0; h = 0; isSelected = 0; CtrlName[ 0 ] = 0;
                         prop_Caption[ 0 ] = 0; prop_Transparent = 0; prop_Visible = 1;
                         prop_Disabled = 0; prop_CenterVertically = 1; prop_NoPrefix = 1;
                         prop_NoWrap = 1; prop_Simple = 0; prop_AlignText = SS_CENTER; prop_Border = 0;
   };
   ~CMyTextLabel( void ){};
};


//---------------------------------------------------------------------------------------
struct CMyPictureBox
{
   UINT   struct_sign;
   
   // std members
   int    x, y;
   int    w, h;
   char   isSelected;
   char   CtrlName[ 64 ];
   
   // speciefic members
   char    prop_FileName[ MAX_PATH ];
   char    prop_Visible;
   char    prop_Border;
   char    prop_Tile;
   HBITMAP Image;
   int     ImageWidth, ImageHeight;// protected

   // contructor & destructor
   CMyPictureBox( void ){ struct_sign = WS_ID_PICTUREBOX; x = 0; y = 0; w = 0; h = 0; isSelected = 0; CtrlName[ 0 ] = 0;
                          prop_FileName[ 0 ] = 0; prop_Visible = 1; prop_Border = 1; Image = NULL;
                          prop_Tile = 0; ImageWidth = 0; ImageHeight = 0;
   };
   ~CMyPictureBox( void ){ DeleteObject( Image ); };
};


//---------------------------------------------------------------------------------------
struct DragStruct
{
   int         BoundOffsetX;
   int         BoundOffsetY;
   CMyStruct  *DragCtrl;
};


//---------------------------------------------------------------------------------------
class CMyDialogEditor : public CWnd
{
   CFont       OurFont;

   int         NumOfStructs;
   void       *Structs_ptr[ WS_MAXCTRLSCOUNT ];
   char        isNeedToInvalidate;
   char        isDragging;
   char        isDraggingSelection;
   RECT        DragRect;
   
   int         NumOfDraggingCtrls;
   DragStruct  DragStructs[ WS_MAXSELECTEDCTRLS ];
   int         MouseDragOffsetX;
   int         MouseDragOffsetY;
   
   char        isResizing;
   char        ResizeType;
   RECT        ResizeRect;
   CMyStruct  *ResizeCtrl;
   
   char        isGrid;
   int         GridLen;
   
   void        DrawBorderStuff( CDC *cdc, RECT *ctrlrect );
   void        DrawSizingStuff( CDC *cdc, RECT *ctrlrect );
   void        CheckUpDragRect( LPRECT rc );
   void        DrawSelRect( LPRECT rc, POINT mouse );
   void        SelectCtrlsUnderSelRect( void );
   void        SetResizeRectangle( POINT pt );
   void        RedrawCtrl( CMyStruct  *lp_cmys, bool redrawselonly = false );
   
public:
	void DrawMyPictureBox( CMyPictureBox *pb, CDC *cdc );
	void        DrawDisabledText( CDC *cdc, char *text, RECT *rc, UINT nFormat );
	void        DrawMyTextLabel( CMyTextLabel *tlab, CDC *cdc );
	void        DrawMyButton( CMyButton *btn, CDC *cdc );

               CMyDialogEditor();
   virtual    ~CMyDialogEditor();
   
   int         AddStruct( void *struct_ptr, int struct_len );
   void        MyPaint( CDC *cdc );
   void        MouseMove( WPARAM wParam, LPARAM lParam ); 
   void        MouseRButtonDown( WPARAM wParam, LPARAM lParam ); 
   void        MouseLButtonDown( WPARAM wParam, LPARAM lParam ); 
   void        MouseLButtonUp( WPARAM wParam, LPARAM lParam ); 
   void        DeselectAll( void );
   void        InvalidateIfNeeded( void );
   int         GetSelectedCount( void );
   CMyStruct  *GetCtrlUnderPtr( POINT pt );
   int         LoadOurBitmapIntoMyPictureBox( CMyPictureBox *cmpb );
   
   
   //{{AFX_VIRTUAL(CMyDialogEditor)
protected:
   virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
   //}}AFX_VIRTUAL
protected:
   //{{AFX_MSG(CMyDialogEditor)
	afx_msg void OnPaint();
	//}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}


#endif // !defined(AFX_MYDIALOGEDITOR_H__81E7691F_D70D_436C_9330_975B4308FF46__INCLUDED_)
