#include "stdafx.h"
#include "MyProps.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//---------------------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CMyProps, CWnd)
	//{{AFX_MSG_MAP(CMyProps)
	ON_WM_SETCURSOR()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_TIMER()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//---------------------------------------------------------------------------------------
CMyProps::CMyProps()
{
   NumOfStructs = 0;
   HeaderDeviderPos = 140;
   isHeaderDragging = 0;
   CurrentCtrl = NULL;
   TopItem = 0;
   NumOfItemsCanBeDisplayed = 0;
   isUpPressed = 0;
   isDownPressed = 0;
   isUpAndDown = 0;
   UpAndDownTimerCount = 0;
}


//---------------------------------------------------------------------------------------
CMyProps::~CMyProps()
{
   for( int i = 0; i < NumOfStructs; i++ )
   {
      delete []Structs_ptr[ i ];
   }
}


//---------------------------------------------------------------------------------------
LRESULT CMyProps::WindowProc( UINT message, WPARAM wParam, LPARAM lParam )
{
   if( message == WM_CREATE )
   {
      CreateControls();
      // setup fonts
      LOGFONT lf;
      memset( &lf, 0, sizeof( LOGFONT ) );
      lf.lfHeight = 14;
      lf.lfWeight = FW_NORMAL;
      strcpy( lf.lfFaceName, "Arial" );
      OurFont.CreateFontIndirect( &lf );
      // calculate num of items who can be displayed
   }

   if( message == WM_SIZE )
   {
      CalculationsByWindowSize();
   }
   if( message == WM_SHOWWINDOW )
   {
      CalculationsByWindowSize();
   }

   if( message == WM_PAINT )
   {
      // paint our controls
      PAINTSTRUCT Paint;
      CDC *cdc;
      cdc = BeginPaint( &Paint );
      PaintOurProperties( cdc );
      EndPaint( &Paint );
   }
   
   if( message == WM_COMMAND )
   {
      if( LOWORD( wParam ) == MYCBUTTON_ID )
      {
         if( CurrentCtrl->struct_sign == MP_ID_EDIT )
         {
            CMyPropEditStruct *cmpes = (CMyPropEditStruct*)CurrentCtrl;
            //MessageBox( "Find file", cmpes->FileFilter );
            
            char ts[ MAX_PATH ]; ts[ 0 ] = 0;
            cmpes->ofn.hwndOwner = this->GetSafeHwnd();
            cmpes->ofn.lpstrFile = ts;
            cmpes->ofn.hInstance = NULL;

            if( !GetOpenFileName( &cmpes->ofn ) ) return true;
            lstrcpy( cmpes->EditText, ts );
            MyCEdit.SetWindowText( cmpes->EditText );
            return true;
         }

         if( CurrentCtrl->struct_sign == MP_ID_COLOR )
         {
            CMyPropColorStruct *cmpcs = (CMyPropColorStruct*)CurrentCtrl;
            // show color dialog
            // MyCColorDialog.SetCurrentColor( cmpcs->Color );
            MyCColorDialog.m_cc.Flags = CC_FULLOPEN | CC_RGBINIT;
            MyCColorDialog.m_cc.rgbResult = cmpcs->Color;
            if( MyCColorDialog.DoModal() == IDOK )
            {
               // save changes
               cmpcs->Color = MyCColorDialog.GetColor();
               Invalidate();
            }
            return true;
         }

         if( CurrentCtrl->struct_sign == MP_ID_FONT )
         {
            CMyPropFontStruct *cmpfs = (CMyPropFontStruct*)CurrentCtrl;
            
            CHOOSEFONT cf;
            LOGFONT    LF;

            CDC *cdc = GetDC();
            int caps = GetDeviceCaps( cdc->GetSafeHdc(), LOGPIXELSY );
            ReleaseDC( cdc );

            lstrcpy( LF.lfFaceName, cmpfs->FontName );
            LF.lfWeight = 0;
            if( cmpfs->isBold ) LF.lfWeight = FW_BOLD;
            LF.lfItalic = cmpfs->isItalic;
            LF.lfStrikeOut = cmpfs->isStrikeOut;
            LF.lfUnderline = cmpfs->isUnderline;
            LF.lfCharSet = cmpfs->CharSet;
            LF.lfHeight = -MulDiv( cmpfs->FontSize, caps, 72 );
            LF.lfWidth = 0;
            
            cf.lStructSize = sizeof( CHOOSEFONT );
            cf.hwndOwner = this->GetSafeHwnd();
            cf.lpLogFont = &LF;
            cf.Flags = CF_INITTOLOGFONTSTRUCT | CF_EFFECTS | CF_BOTH;
            cf.nSizeMin = 2;
            cf.nSizeMax = 100;
            cf.iPointSize = 1;

            // show font dialog
            if( ChooseFont( &cf ) )
            {
               // save
               lstrcpy( cmpfs->FontName, LF.lfFaceName );
               cmpfs->isBold = 0;
               if( LF.lfWeight == FW_BOLD ) cmpfs->isBold = 1;
               cmpfs->isItalic = LF.lfItalic;
               cmpfs->isStrikeOut = LF.lfStrikeOut;
               cmpfs->isUnderline = LF.lfUnderline;
               cmpfs->CharSet = LF.lfCharSet;
               cmpfs->FontSize = -MulDiv( LF.lfHeight, 72, caps );
               
               Invalidate();
            }
            return true;
         }

      }
   }
   if( message == WM_DESTROY )
   {
      LastCtrlUpdate();// last update
   }

   return CWnd::WindowProc( message, wParam, lParam );
}


//---------------------------------------------------------------------------------------
int CMyProps::AddStruct( void *struct_ptr, int struct_len )
{
   CMyPropStruct *lp_cmys = (CMyPropStruct*)struct_ptr;
   if( lp_cmys->struct_sign != MP_ID_EDIT && 
       lp_cmys->struct_sign != MP_ID_BOOLEAN &&
       lp_cmys->struct_sign != MP_ID_COMBO &&
       lp_cmys->struct_sign != MP_ID_COLOR &&
       lp_cmys->struct_sign != MP_ID_FONT
     )
   { 
      AfxMessageBox( "undef type" );
      return 0;
   }
   if( NumOfStructs + 1 > MP_MAXCOUNT ) return 0;
   Structs_ptr[ NumOfStructs ] = (void*)new UCHAR[ struct_len ];
   memcpy( Structs_ptr[ NumOfStructs ], struct_ptr, struct_len );
   CMyPropStruct *cmps = (CMyPropStruct*)Structs_ptr[ NumOfStructs ];
   cmps->Index = NumOfStructs;
   cmps->isSelected = 0;
   NumOfStructs++;
   return 1;
}


//---------------------------------------------------------------------------------------
void CMyProps::PaintOurProperties( CDC *cdc )
{
   RECT wrc, rc;
   GetClientRect( &wrc );
   cdc->FillSolidRect( &wrc, GetSysColor( COLOR_BTNFACE ) );
   
   //
   // draw header and header text
   //
   CopyRect( &rc, &wrc );

   cdc->SelectObject( OurFont );

   rc.left += 2; rc.right = rc.left + HeaderDeviderPos;
   rc.top += 2; rc.bottom = rc.top + 20;
   cdc->Draw3dRect( &rc, GetSysColor( COLOR_3DHILIGHT ), GetSysColor( COLOR_3DDKSHADOW ) );
   cdc->SetBkColor( GetSysColor( COLOR_BTNFACE ) );
   cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
   cdc->DrawText( "NAME", 4, &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );

   rc.left = rc.right + 1; rc.right = wrc.right - 2;
   cdc->Draw3dRect( &rc, GetSysColor( COLOR_3DHILIGHT ), GetSysColor( COLOR_3DDKSHADOW ) );
   cdc->SetBkColor( GetSysColor( COLOR_BTNFACE ) );
   cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
   cdc->DrawText( "VALUE", 5, &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );

   // draw ctrls
   for( int n = TopItem; n < NumOfStructs; n++ )
   {
      if( n + 1 > TopItem + NumOfItemsCanBeDisplayed ) break;
      RedrawCtrl( (CMyPropStruct*)Structs_ptr[ n ], cdc );
   }

   // check for up/down control
   if( NumOfItemsCanBeDisplayed != NumOfStructs )
   {
      RECT up, dw;
      SetRect( &up, wrc.left + 2, wrc.bottom - 20, wrc.left + ( wrc.right - wrc.left ) / 2 - 1, wrc.bottom - 2 );
      SetRect( &dw, wrc.left + ( wrc.right - wrc.left ) / 2 + 1, wrc.bottom - 20, wrc.right - 2, wrc.bottom - 2 );
      
      cdc->SetBkMode( TRANSPARENT );
      // draw up
      if( !TopItem )
      {
         // disabled
         cdc->SetTextColor( GetSysColor( COLOR_HIGHLIGHTTEXT ) );
         up.left+=2; up.top+=2;
         cdc->DrawText( "up", 2, &up, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
         up.left-=2; up.top-=2;
         cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
         cdc->DrawText( "up", 2, &up, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
      }else{
         // enabled
         cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
         cdc->DrawText( "up", 2, &up, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
      }
      if( !isUpPressed )
         cdc->Draw3dRect( &up, GetSysColor( COLOR_3DHILIGHT ), GetSysColor( COLOR_3DDKSHADOW ) );
      else
         cdc->Draw3dRect( &up, GetSysColor( COLOR_3DDKSHADOW ), GetSysColor( COLOR_3DHILIGHT ) );

      // draw down
      if( TopItem + NumOfItemsCanBeDisplayed >= NumOfStructs )
      {
         // disabled
         cdc->SetTextColor( GetSysColor( COLOR_HIGHLIGHTTEXT ) );
         dw.left+=2; dw.top+=2;
         cdc->DrawText( "down", 4, &dw, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
         dw.left-=2; dw.top-=2;
         cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
         cdc->DrawText( "down", 4, &dw, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
      }else{
         // enabled
         cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
         cdc->DrawText( "down", 4, &dw, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
      }
      if( !isDownPressed )
         cdc->Draw3dRect( &dw, GetSysColor( COLOR_3DHILIGHT ), GetSysColor( COLOR_3DDKSHADOW ) );
      else
         cdc->Draw3dRect( &dw, GetSysColor( COLOR_3DDKSHADOW ), GetSysColor( COLOR_3DHILIGHT ) );
   }


   //
   // draw border
   //
   cdc->Draw3dRect( &wrc, GetSysColor( COLOR_3DHILIGHT ), GetSysColor( COLOR_3DDKSHADOW ) );
}


//---------------------------------------------------------------------------------------
void CMyProps::DeselectAll( void )
{
   // save previous
   LastCtrlUpdate();

   for( int n = 0; n < NumOfStructs; n++ )
   {
      CMyPropStruct *cmps = (CMyPropStruct*)Structs_ptr[ n ];
      if( cmps->isSelected )
      {
         cmps->isSelected = 0;
         // redraw
         RedrawCtrl( cmps );
      }
   }
}


//---------------------------------------------------------------------------------------
void CMyProps::RedrawCtrl( CMyPropStruct *ctrl, CDC *cdc )
{
   bool myinvalidate = false;
   if( cdc == NULL ){ cdc = GetDC(); myinvalidate = true; }

   RECT wrc;
   GetClientRect( &wrc );
   int Index;
   Index = ctrl->Index - TopItem;

   RECT NameRc, ValueRc;
   SetRect( &NameRc, wrc.left + 2, wrc.top + Index * 23 + 25,
            wrc.left + HeaderDeviderPos + 2, wrc.top + Index * 23 + 22 + 25 );
   SetRect( &ValueRc, NameRc.right + 1, wrc.top + Index * 23 + 25,
            wrc.right - 2, wrc.top + Index * 23 + 22 + 25 );

   if( ctrl->struct_sign == MP_ID_EDIT )
   {
      // draw edit ctrls
      CMyPropEditStruct *cmpes = (CMyPropEditStruct*)ctrl;

      // draw text
      cdc->SetBkMode( TRANSPARENT );
      cdc->SetBkColor( GetSysColor( COLOR_BTNFACE ) );
      if( cmpes->isSelected )
         cdc->SetTextColor( GetSysColor( COLOR_HIGHLIGHTTEXT ) );
      else{
         cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
         if( !cmpes->isEnabled )
            cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
      }
      
      // set up the font
      cdc->SelectObject( OurFont );
      NameRc.left += 4; ValueRc.left += 4;
      cdc->DrawText( cmpes->PropName, lstrlen( cmpes->PropName ), &NameRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
      if( !cmpes->isSelected )
         cdc->DrawText( cmpes->EditText, lstrlen( cmpes->EditText ), &ValueRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
      NameRc.left -= 4; ValueRc.left -= 4;
   }
   
   if( ctrl->struct_sign == MP_ID_BOOLEAN )
   {
      // draw bool ctrls
      CMyPropBoolStruct *cmpbs = (CMyPropBoolStruct*)ctrl;

      // draw text
      cdc->SetBkMode( TRANSPARENT );
      cdc->SetBkColor( GetSysColor( COLOR_BTNFACE ) );
      if( cmpbs->isSelected )
         cdc->SetTextColor( GetSysColor( COLOR_HIGHLIGHTTEXT ) );
      else{
         cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
         if( !cmpbs->isEnabled )
            cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
      }
      
      // set up the font
      cdc->SelectObject( OurFont );
      NameRc.left += 4; ValueRc.left += 4;
      cdc->DrawText( cmpbs->PropName, lstrlen( cmpbs->PropName ), &NameRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
      if( !cmpbs->isSelected )
         if( cmpbs->Result )
         {
            cdc->DrawText( "True", 4, &ValueRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
         }else{
            cdc->DrawText( "False", 5, &ValueRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
         }
      NameRc.left -= 4; ValueRc.left -= 4;
   }
   
   if( ctrl->struct_sign == MP_ID_COMBO )
   {
      // draw combo ctrls
      CMyPropComboStruct *cmpcs = (CMyPropComboStruct*)ctrl;

      // draw text
      cdc->SetBkMode( TRANSPARENT );
      cdc->SetBkColor( GetSysColor( COLOR_BTNFACE ) );
      if( cmpcs->isSelected )
         cdc->SetTextColor( GetSysColor( COLOR_HIGHLIGHTTEXT ) );
      else{
         cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
         if( !cmpcs->isEnabled )
            cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
      }
      
      // set up the font
      cdc->SelectObject( OurFont );
      NameRc.left += 4; ValueRc.left += 4;
      cdc->DrawText( cmpcs->PropName, lstrlen( cmpcs->PropName ), &NameRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
      if( !cmpcs->isSelected )
         if( cmpcs->Combotype == MP_CBT_DROPDOWN )
         {
            if( cmpcs->SelIndex == -1 )
               cdc->DrawText( cmpcs->SelText, lstrlen( cmpcs->SelText ), &ValueRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
            else
               cdc->DrawText( cmpcs->Strings[ cmpcs->SelIndex ], lstrlen( cmpcs->Strings[ cmpcs->SelIndex ] ), &ValueRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
         }else{
            cdc->DrawText( cmpcs->Strings[ cmpcs->SelIndex ], lstrlen( cmpcs->Strings[ cmpcs->SelIndex ] ), &ValueRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
         }
      //   cdc->DrawText( "True", 4, &ValueRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
      NameRc.left -= 4; ValueRc.left -= 4;
   }

   if( ctrl->struct_sign == MP_ID_COLOR )
   {
      // draw color ctrls
      CMyPropColorStruct *cmpcs = (CMyPropColorStruct*)ctrl;

      // draw text
      cdc->SetBkMode( TRANSPARENT );
      cdc->SetBkColor( GetSysColor( COLOR_BTNFACE ) );
      if( cmpcs->isSelected )
         cdc->SetTextColor( GetSysColor( COLOR_HIGHLIGHTTEXT ) );
      else{
         cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
         if( !cmpcs->isEnabled )
            cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
      }
      
      // set up the font
      cdc->SelectObject( OurFont );
      NameRc.left += 4; ValueRc.left += 4;
      cdc->DrawText( cmpcs->PropName, lstrlen( cmpcs->PropName ), &NameRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
      // draw color
      RECT crc; SetRect( &crc, ValueRc.left, ValueRc.top + 2, ValueRc.left + 20, ValueRc.bottom - 2 );
      cdc->FillSolidRect( &crc, cmpcs->Color );
      char ts[ 100 ];
      wsprintf( ts, "R=%i, G=%i, B=%i", GetRValue( cmpcs->Color ), GetGValue( cmpcs->Color ), GetBValue( cmpcs->Color ) );
      CopyRect( &crc, &ValueRc ); crc.left += 24;
      if( !cmpcs->isEnabled )
         cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
      cdc->DrawText( ts, lstrlen( ts ), &crc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
      NameRc.left -= 4; ValueRc.left -= 4;
   }
   
   if( ctrl->struct_sign == MP_ID_FONT )
   {
      // draw font ctrls
      CMyPropFontStruct *cmpfs = (CMyPropFontStruct*)ctrl;

      // draw text
      cdc->SetBkMode( TRANSPARENT );
      cdc->SetBkColor( GetSysColor( COLOR_BTNFACE ) );
      if( cmpfs->isSelected )
         cdc->SetTextColor( GetSysColor( COLOR_HIGHLIGHTTEXT ) );
      else{
         cdc->SetTextColor( GetSysColor( COLOR_BTNTEXT ) );
         if( !cmpfs->isEnabled )
            cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
      }
      
      // set up the font
      cdc->SelectObject( OurFont );
      NameRc.left += 4; ValueRc.left += 4;
      cdc->DrawText( cmpfs->PropName, lstrlen( cmpfs->PropName ), &NameRc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
      char ts[ 100 ];
      wsprintf( ts, "%s,%i", cmpfs->FontName, cmpfs->FontSize );
      if( cmpfs->isBold ) lstrcat( ts, ",bold" );
      if( cmpfs->isItalic ) lstrcat( ts, ",ita" );
      if( cmpfs->isUnderline ) lstrcat( ts, ",undrln" );
      if( cmpfs->isStrikeOut ) lstrcat( ts, ",strkout" );
      RECT crc; CopyRect( &crc, &ValueRc ); crc.right += 28;
      if( !cmpfs->isEnabled )
         cdc->SetTextColor( GetSysColor( COLOR_GRAYTEXT ) );
      cdc->DrawText( ts, lstrlen( ts ), &crc, DT_LEFT | DT_SINGLELINE | DT_VCENTER );
      NameRc.left -= 4; ValueRc.left -= 4;
   }
   

   // draw frames
   if( ctrl->isSelected )
   {
      cdc->Draw3dRect( &NameRc, GetSysColor( COLOR_3DDKSHADOW ), GetSysColor( COLOR_3DHIGHLIGHT ) );
      cdc->Draw3dRect( &ValueRc, GetSysColor( COLOR_3DDKSHADOW ), GetSysColor( COLOR_3DHIGHLIGHT ) );
   }else{
      cdc->Draw3dRect( &NameRc, GetSysColor( COLOR_3DHILIGHT ), GetSysColor( COLOR_3DDKSHADOW ) );
      cdc->Draw3dRect( &ValueRc, GetSysColor( COLOR_3DHILIGHT ), GetSysColor( COLOR_3DDKSHADOW ) );
   }
   
   if( myinvalidate )
   {
      InvalidateRect( &NameRc );
      InvalidateRect( &ValueRc );
      ReleaseDC( cdc );
   }
}


//---------------------------------------------------------------------------------------
BOOL CMyProps::OnSetCursor( CWnd* pWnd, UINT nHitTest, UINT message )
{
   if( CurrentCtrl == NULL )
   {
      POINT pt;
      RECT wrc;
      GetCursorPos( &pt );
      GetWindowRect( &wrc );
      if( PtInRect( &wrc, pt ) ) return true;// use to kick cursor flickering
   }
   
   return CWnd::OnSetCursor( pWnd, nHitTest, message );
}


//---------------------------------------------------------------------------------------
void CMyProps::OnMouseMove( UINT nFlags, CPoint point )
{
   CWnd::OnMouseMove( nFlags, point );

   RECT wrc, rc;
   GetClientRect( &wrc );
   SIZE size; size.cx = 2; size.cy = size.cx;

   if( isHeaderDragging )
   {
      RECT rc1;
      SetRect( &rc1, wrc.left + HeaderDragPos, wrc.top + 2, wrc.left + HeaderDragPos + 2, wrc.top + NumOfItemsCanBeDisplayed * 25 + 16 );
      HeaderDragPos = point.x;
      if( HeaderDragPos < wrc.left + 50 ) HeaderDragPos = wrc.left + 50;
      if( HeaderDragPos > wrc.right - 50 ) HeaderDragPos = wrc.right - 50;
      SetRect( &rc, wrc.left + HeaderDragPos, wrc.top + 2, wrc.left + HeaderDragPos + 2, wrc.top + NumOfItemsCanBeDisplayed * 25 + 16 );
      CDC *cdc = GetDC();
      cdc->DrawDragRect( &rc, size, &rc1, size );
      ReleaseDC( cdc );
      return;
   }

   if( NumOfItemsCanBeDisplayed != NumOfStructs && isUpAndDown )
   {
      RECT up, dw;
      SetRect( &up, wrc.left + 2, wrc.bottom - 20, wrc.left + ( wrc.right - wrc.left ) / 2 - 1, wrc.bottom - 2 );
      SetRect( &dw, wrc.left + ( wrc.right - wrc.left ) / 2 + 1, wrc.bottom - 20, wrc.right - 2, wrc.bottom - 2 );

      if( !isUpPressed && PtInRect( &up, point ) && isUpAndDown == 1 )
      {
         isUpPressed = 1;
         InvalidateRect( &up );
      }
      if( !isDownPressed && PtInRect( &dw, point )  && isUpAndDown == 2 )
      {
         isDownPressed = 1;
         InvalidateRect( &dw );
      }
   }

   //
   // check for cursor changes
   //
   SetRect( &rc, wrc.left + HeaderDeviderPos - 2, wrc.top + 2, wrc.left + HeaderDeviderPos + 8, wrc.top + NumOfItemsCanBeDisplayed * 25 + 16 );
   // check for header
   if( PtInRect( &rc, point ) )
   {
      SetCursor( LoadCursor( NULL, IDC_SIZEWE ) );// size arrow
   }else{
      SetCursor( LoadCursor( NULL, IDC_ARROW ) );// normal arrow
   }
   
}


//---------------------------------------------------------------------------------------
void CMyProps::OnLButtonDown( UINT nFlags, CPoint point )
{
	CWnd::OnLButtonDown( nFlags, point );

   // check header drag
   RECT wrc, rc;
   GetClientRect( &wrc );
   SIZE size; size.cx = 2; size.cy = size.cx;
   
   SetRect( &rc, wrc.left + HeaderDeviderPos - 2, wrc.top + 2, wrc.left + HeaderDeviderPos + 8, wrc.top + NumOfItemsCanBeDisplayed * 25 + 16 );
   if( PtInRect( &rc, point ) )
   {
      // ok we drag header at now
      isHeaderDragging = 1;
      HeaderDragPos = point.x;
      SetRect( &rc, wrc.left + HeaderDragPos, wrc.top + 2, wrc.left + HeaderDragPos + 2, wrc.top + NumOfItemsCanBeDisplayed * 25 + 16 );
      CDC *cdc = GetDC();
      cdc->DrawDragRect( &rc, size, NULL, size );
      ReleaseDC( cdc );
      SetCapture();// capture mouse input
      return;
   }

   // check for up/down click
   if( NumOfItemsCanBeDisplayed != NumOfStructs )
   {
      RECT up, dw;
      SetRect( &up, wrc.left + 2, wrc.bottom - 20, wrc.left + ( wrc.right - wrc.left ) / 2 - 1, wrc.bottom - 2 );
      SetRect( &dw, wrc.left + ( wrc.right - wrc.left ) / 2 + 1, wrc.bottom - 20, wrc.right - 2, wrc.bottom - 2 );
      
      if( PtInRect( &up, point ) )
      {
         if( !TopItem ) return;// nothing to do
         DeselectAll();
         // MessageBox( "up" );
         isUpAndDown = 1;
         isUpPressed = 1;
         UpAndDownTimerCount = 0;
         TopItem--;
         InvalidateCtrls();
         InvalidateRect( &up ); InvalidateRect( &dw );// invalidate up/down
         SetCapture();// capture mouse input
         SetTimer( MP_UPANDDOWNTIMERID, 100, NULL );
         return;
      }
      if( PtInRect( &dw, point ) )
      {
         if( TopItem + NumOfItemsCanBeDisplayed >= NumOfStructs ) return;// nothing to do
         DeselectAll();
         // MessageBox( "down" );
         isUpAndDown = 2;
         isDownPressed = 1;
         UpAndDownTimerCount = 0;
         TopItem++;
         InvalidateCtrls();
         InvalidateRect( &up ); InvalidateRect( &dw );// invalidate up/down
         SetCapture();// capture mouse input
         SetTimer( MP_UPANDDOWNTIMERID, 100, NULL );
         return;
      }
   }

   
   // check for ctrl click
   CMyPropStruct *myctrl;
   myctrl = GetCtrlUnderPtr( point );
   if( myctrl != NULL )
   {
      int Index;
      Index = myctrl->Index - TopItem;

      RECT ValueRc;
      SetRect( &ValueRc, wrc.left + HeaderDeviderPos + 3, wrc.top + Index * 23 + 25,
               wrc.right - 2, wrc.top + Index * 23 + 22 + 25 );
      DeselectAll();
      myctrl->isSelected = 1;
      RedrawCtrl( myctrl );
      // now apply control
      if( myctrl->struct_sign == MP_ID_EDIT )
      {
         CMyPropEditStruct *cmpes = (CMyPropEditStruct*)myctrl;
         CurrentCtrl = (CMyPropStruct*)cmpes;

         // setup edit control
         int x, y, cx, cy;
         x = ValueRc.left + 2; y = ValueRc.top + 2;
         cx = ValueRc.right - ValueRc.left - 4;
         cy = ValueRc.bottom - ValueRc.top - 4;
         if( cmpes->isFileName )
         {
            MyCButton.SetWindowPos( NULL, x + cx - 25, y, 25, cy, SWP_NOZORDER );
            MyCButton.SetWindowText( "..." );
            MyCButton.SetFont( &OurFont );
            MyCButton.EnableWindow();
            if( !cmpes->isEnabled ) MyCButton.EnableWindow( false );
            MyCButton.ShowWindow( SW_SHOW );
            cx -= 28;
         }

         MyCEdit.SetLimitText( MAX_PATH );
         MyCEdit.SetWindowPos( NULL, x, y, cx, cy, SWP_NOZORDER );
         MyCEdit.SetWindowText( cmpes->EditText );
         MyCEdit.SetFont( &OurFont );
         MyCEdit.SetReadOnly( cmpes->isReadOnly );
         MyCEdit.EnableWindow();
         if( !cmpes->isEnabled ) MyCEdit.EnableWindow( false );
         MyCEdit.ShowWindow( SW_SHOW );
      }

      if( myctrl->struct_sign == MP_ID_BOOLEAN )
      {
         // setup bool ctrls
         CMyPropBoolStruct *cmpbs = (CMyPropBoolStruct*)myctrl;
         CurrentCtrl = (CMyPropStruct*)cmpbs;

         int x, y, cx, cy;
         x = ValueRc.left; y = ValueRc.top;
         cx = ValueRc.right - ValueRc.left;
         cy = ValueRc.bottom - ValueRc.top - 6 + 100;

         MyCComboBox.DestroyWindow();
         MyCComboBox.Create( WS_CHILD | CBS_DROPDOWNLIST | WS_VSCROLL, CRect( 0, 0, 1, 1 ), this, MYCCOMBOBOX_ID );
         //MyCComboBox.ResetContent();
         MyCComboBox.AddString( "True" );
         MyCComboBox.AddString( "False" );
         MyCComboBox.SetFont( &OurFont );
         MyCComboBox.SetWindowPos( NULL, x, y, cx, cy, SWP_NOZORDER );

         if( cmpbs->Result ) MyCComboBox.SetCurSel( 0 );
         else MyCComboBox.SetCurSel( 1 );
         MyCComboBox.EnableWindow();
         if( !cmpbs->isEnabled ) MyCComboBox.EnableWindow( false );
         MyCComboBox.ShowWindow( SW_SHOW );
      }

      if( myctrl->struct_sign == MP_ID_COMBO )
      {
         // setup combo ctrls
         CMyPropComboStruct *cmpcs = (CMyPropComboStruct*)myctrl;
         CurrentCtrl = (CMyPropStruct*)cmpcs;

         int x, y, cx, cy;
         x = ValueRc.left; y = ValueRc.top;
         cx = ValueRc.right - ValueRc.left;
         cy = ValueRc.bottom - ValueRc.top - 6 + 100;

         // recreate combo box
         if( cmpcs->Combotype == MP_CBT_DROPDOWN )
         {
            MyCComboBox.DestroyWindow();
            MyCComboBox.Create( WS_CHILD | CBS_DROPDOWN | WS_VSCROLL, CRect( 0, 0, 1, 1 ), this, MYCCOMBOBOX_ID );
         }else{
            MyCComboBox.DestroyWindow();
            MyCComboBox.Create( WS_CHILD | CBS_DROPDOWNLIST | WS_VSCROLL, CRect( 0, 0, 1, 1 ), this, MYCCOMBOBOX_ID );
         }
         // MyCComboBox.ResetContent();
         for( int l = 0; l < cmpcs->NumOfStrings; l++ )
            MyCComboBox.AddString( cmpcs->Strings[ l ] );
         if( cmpcs->Combotype == MP_CBT_DROPDOWN )
         {
            if( cmpcs->SelIndex != -1 )
               MyCComboBox.SetCurSel( cmpcs->SelIndex );
            else
               MyCComboBox.SetWindowText( cmpcs->SelText );
         }else{
            MyCComboBox.SetCurSel( cmpcs->SelIndex );
         }
         MyCComboBox.SetFont( &OurFont );
         MyCComboBox.SetWindowPos( NULL, x, y, cx, cy, SWP_NOZORDER );
         MyCComboBox.EnableWindow();
         if( !cmpcs->isEnabled ) MyCComboBox.EnableWindow( false );
         if( cmpcs->Combotype == MP_CBT_DROPDOWN ) MyCComboBox.SetEditSel( 0, 0 );
         MyCComboBox.ShowWindow( SW_SHOW );
      }
      
      if( myctrl->struct_sign == MP_ID_COLOR )
      {
         // setup color ctrls
         CMyPropColorStruct *cmpcs = (CMyPropColorStruct*)myctrl;
         CurrentCtrl = (CMyPropStruct*)cmpcs;

         int x, y, cx, cy;
         x = ValueRc.left + 2; y = ValueRc.top + 2;
         cx = ValueRc.right - ValueRc.left - 4;
         cy = ValueRc.bottom - ValueRc.top - 4;

         MyCButton.SetWindowPos( NULL, x + cx - 25, y, 25, cy, SWP_NOZORDER );
         MyCButton.SetWindowText( "..." );
         MyCButton.SetFont( &OurFont );
         MyCButton.EnableWindow();
         if( !cmpcs->isEnabled ) MyCButton.EnableWindow( false );
         MyCButton.ShowWindow( SW_SHOW );
      }

      if( myctrl->struct_sign == MP_ID_FONT )
      {
         // setup font ctrls
         CMyPropFontStruct *cmpfs = (CMyPropFontStruct*)myctrl;
         CurrentCtrl = (CMyPropStruct*)cmpfs;

         int x, y, cx, cy;
         x = ValueRc.left + 2; y = ValueRc.top + 2;
         cx = ValueRc.right - ValueRc.left - 4;
         cy = ValueRc.bottom - ValueRc.top - 4;

         MyCButton.SetWindowPos( NULL, x + cx - 25, y, 25, cy, SWP_NOZORDER );
         MyCButton.SetWindowText( "..." );
         MyCButton.SetFont( &OurFont );
         MyCButton.EnableWindow();
         if( !cmpfs->isEnabled ) MyCButton.EnableWindow( false );
         MyCButton.ShowWindow( SW_SHOW );
      }

   }else{
      // deselect all ctrls
      DeselectAll();
   }
}


//---------------------------------------------------------------------------------------
void CMyProps::OnLButtonUp( UINT nFlags, CPoint point )
{
	CWnd::OnLButtonUp( nFlags, point );
   RECT wrc, rc;
   GetClientRect( &wrc );
   SIZE size; size.cx = 2; size.cy = size.cx;

   if( NumOfItemsCanBeDisplayed != NumOfStructs )
   {
      RECT up, dw;
      SetRect( &up, wrc.left + 2, wrc.bottom - 20, wrc.left + ( wrc.right - wrc.left ) / 2 - 1, wrc.bottom - 2 );
      SetRect( &dw, wrc.left + ( wrc.right - wrc.left ) / 2 + 1, wrc.bottom - 20, wrc.right - 2, wrc.bottom - 2 );

      if( isUpAndDown == 1 )
      {
         isUpPressed = 0;
         isUpAndDown = 0;
         ReleaseCapture();// release mouse input
         InvalidateRect( &up );
         KillTimer( MP_UPANDDOWNTIMERID );
         return;
      }
      if( isUpAndDown == 2 )
      {
         isDownPressed = 0;
         isUpAndDown = 0;
         ReleaseCapture();// release mouse input
         InvalidateRect( &dw );
         KillTimer( MP_UPANDDOWNTIMERID );
         return;
      }
   }

   if( isHeaderDragging )
   {
      SetRect( &rc, wrc.left + HeaderDragPos, wrc.top + 2, wrc.left + HeaderDragPos + 2, wrc.top + NumOfItemsCanBeDisplayed * 25 + 16 );
      CDC *cdc = GetDC();
      cdc->DrawDragRect( &rc, size, NULL, size );
      ReleaseDC( cdc );
      isHeaderDragging = 0;
      ReleaseCapture();// release mouse input
      HeaderDeviderPos = HeaderDragPos;
      // resize ctrls
      OnSize( 0, wrc.right - wrc.left, wrc.bottom - wrc.top );
      return;
   }

}


//---------------------------------------------------------------------------------------
CMyPropStruct *CMyProps::GetCtrlUnderPtr( POINT pt )
{
   RECT wrc;
   GetClientRect( &wrc );

   CMyPropStruct *ctrl;
   for( int n = TopItem; n < NumOfStructs; n++ )
   {
      if( n + 1 > TopItem + NumOfItemsCanBeDisplayed ) break;

      ctrl = (CMyPropStruct*)Structs_ptr[ n ];
      RECT NameRc, ValueRc;
      int Index;
      Index = ctrl->Index - TopItem;
      SetRect( &NameRc, wrc.left + 2, wrc.top + Index * 23 + 25,
               wrc.left + HeaderDeviderPos + 2, wrc.top + Index * 23 + 22 + 25 );
      SetRect( &ValueRc, NameRc.right + 1, wrc.top + Index * 23 + 25,
               wrc.right - 2, wrc.top + Index * 23 + 22 + 25 );
      // check for header
      if( PtInRect( &NameRc, pt ) || PtInRect( &ValueRc, pt ) )
      {
         return ctrl;
      }
   }
   return NULL;
}


//---------------------------------------------------------------------------------------
void CMyProps::CreateControls( void )
{
    MyCEdit.Create( WS_CHILD | ES_AUTOHSCROLL, CRect( 0, 0, 1, 1 ), this, MYCEDIT_ID );
    MyCButton.Create( "", WS_CHILD, CRect( 0, 0, 1, 1 ), this, MYCBUTTON_ID );
    // MyCComboBox.Create( WS_CHILD | CBS_DROPDOWNLIST | WS_VSCROLL, CRect( 0, 0, 1, 1 ), this, MYCCOMBOBOX_ID );
}


//---------------------------------------------------------------------------------------
void CMyProps::LastCtrlUpdate( void )
{
   if( CurrentCtrl != NULL )
   {
      
      if( CurrentCtrl->struct_sign == MP_ID_EDIT )
      {
         CMyPropEditStruct *cmpes = (CMyPropEditStruct*)CurrentCtrl;
         MyCEdit.GetWindowText( cmpes->EditText, MAX_PATH );

         MyCEdit.ShowWindow( SW_HIDE );
         MyCButton.ShowWindow( SW_HIDE );
      }
      
      if( CurrentCtrl->struct_sign == MP_ID_BOOLEAN )
      {
         CMyPropBoolStruct *cmpbs = (CMyPropBoolStruct*)CurrentCtrl;
         cmpbs->Result = true;
         if( MyCComboBox.GetCurSel() == 1 ) cmpbs->Result = false;
         MyCComboBox.ShowWindow( SW_HIDE );
      }
      
      if( CurrentCtrl->struct_sign == MP_ID_COMBO )
      {
         CMyPropComboStruct *cmpcs = (CMyPropComboStruct*)CurrentCtrl;

         if( cmpcs->Combotype == MP_CBT_DROPDOWN )
         {
            cmpcs->SelIndex = MyCComboBox.GetCurSel();
            if( cmpcs->SelIndex == - 1 )
               MyCComboBox.GetWindowText( cmpcs->SelText, 64 );
         }else{
            cmpcs->SelIndex = MyCComboBox.GetCurSel();
         }
         
         MyCComboBox.ShowWindow( SW_HIDE );
      }

      if( CurrentCtrl->struct_sign == MP_ID_COLOR )
      {
         MyCButton.ShowWindow( SW_HIDE );
      }

      if( CurrentCtrl->struct_sign == MP_ID_FONT )
      {
         MyCButton.ShowWindow( SW_HIDE );
      }
   }
}


//---------------------------------------------------------------------------------------
void CMyProps::CalculationsByWindowSize( void )
{
//   int            TopItem;
   RECT wrc;
   GetClientRect( &wrc );
   // 24 - header
   wrc.top += 30;
   NumOfItemsCanBeDisplayed = 0;
   for( int i = 0; i < NumOfStructs; i++ )
   {
      if( ( wrc.top + i * 25 ) > ( wrc.bottom - 30 ) ) break;
      NumOfItemsCanBeDisplayed++;
   }
   if( NumOfItemsCanBeDisplayed > NumOfStructs )
   {
      NumOfItemsCanBeDisplayed = NumOfStructs;
      //ShowScrollBar( SB_VERT, false );
   }else{
      //ShowScrollBar( SB_VERT, true );
   }
   //char t[200]; wsprintf( t, "num:%lu,top:%lu,bot:%lu",
   //   NumOfItemsCanBeDisplayed, wrc.top, wrc.bottom);MessageBox(t);
}


//---------------------------------------------------------------------------------------
void CMyProps::InvalidateCtrls( void )
{
   // draw ctrls
   for( int n = TopItem; n < NumOfStructs; n++ )
   {
      if( n + 1 > TopItem + NumOfItemsCanBeDisplayed ) break;
      RedrawCtrl( (CMyPropStruct*)Structs_ptr[ n ] );
   }
}


//---------------------------------------------------------------------------------------
void CMyProps::OnTimer( UINT nIDEvent )
{
   if( nIDEvent == MP_UPANDDOWNTIMERID )
   {
      // check up and down
      RECT up, dw;
      RECT wrc;
      GetClientRect( &wrc );
      SetRect( &up, wrc.left + 2, wrc.bottom - 20, wrc.left + ( wrc.right - wrc.left ) / 2 - 1, wrc.bottom - 2 );
      SetRect( &dw, wrc.left + ( wrc.right - wrc.left ) / 2 + 1, wrc.bottom - 20, wrc.right - 2, wrc.bottom - 2 );
      POINT pt;
      GetCursorPos( &pt );
      ScreenToClient( &pt );

      if( isUpPressed && !PtInRect( &up, pt ) )
      {
         isUpPressed = 0;
         InvalidateRect( &up );
      }

      if( isDownPressed && !PtInRect( &dw, pt ) )
      {
         isDownPressed = 0;
         InvalidateRect( &dw );
      }

      if( isUpPressed && UpAndDownTimerCount++ > 1 && TopItem != 0 )
      {
         UpAndDownTimerCount = 0;
         TopItem--;
         InvalidateCtrls();
         InvalidateRect( &up ); InvalidateRect( &dw );// invalidate up/down
      }

      if( isDownPressed && UpAndDownTimerCount++ > 1 && TopItem + NumOfItemsCanBeDisplayed < NumOfStructs )
      {
         UpAndDownTimerCount = 0;
         TopItem++;
         InvalidateCtrls();
         InvalidateRect( &up ); InvalidateRect( &dw );// invalidate up/down
      }

      return;
   }

   CWnd::OnTimer( nIDEvent );
}


//---------------------------------------------------------------------------------------
void CMyProps::OnSize( UINT nType, int cx1, int cy1 )
{
   CWnd::OnSize( nType, cx1, cy1  );

   RECT wrc;
   GetClientRect( &wrc );

   if( CurrentCtrl != NULL )
   {
      RECT ValueRc;
      SetRect( &ValueRc, wrc.left + HeaderDeviderPos + 3, wrc.top + CurrentCtrl->Index * 23 + 25,
               wrc.right - 2, wrc.top + CurrentCtrl->Index * 23 + 22 + 25 );
      // resize controls
      if( CurrentCtrl->struct_sign == MP_ID_EDIT )
      {
         CMyPropEditStruct *cmpes = (CMyPropEditStruct*)CurrentCtrl;
         // setup edit control
         int x, y, cx, cy;
         x = ValueRc.left + 2; y = ValueRc.top + 2;
         cx = ValueRc.right - ValueRc.left - 4;
         cy = ValueRc.bottom - ValueRc.top - 4;
         if( cmpes->isFileName )
         {
            MyCButton.SetWindowPos( NULL, x + cx - 25, y, 25, cy, SWP_NOZORDER );
            cx -= 28;
         }
         MyCEdit.SetWindowPos( NULL, x, y, cx, cy, SWP_NOZORDER );
         // ensure visible
         if( ValueRc.bottom > wrc.bottom - 21 )
         {
            MyCEdit.ShowWindow( SW_HIDE );
            MyCButton.ShowWindow( SW_HIDE );
         }else{
            MyCEdit.ShowWindow( SW_SHOW );
            MyCButton.ShowWindow( SW_SHOW );
         }
      }
   
      if( CurrentCtrl->struct_sign == MP_ID_BOOLEAN )
      {
         // setup edit control
         int x, y, cx, cy;
         x = ValueRc.left; y = ValueRc.top;
         cx = ValueRc.right - ValueRc.left;
         cy = ValueRc.bottom - ValueRc.top - 6;
         MyCComboBox.SetWindowPos( NULL, x, y, cx, cy, SWP_NOZORDER );
         // ensure visible
         if( ValueRc.bottom > wrc.bottom - 21 )
         {
            MyCComboBox.ShowWindow( SW_HIDE );
         }else{
            MyCComboBox.ShowWindow( SW_SHOW );
         }
      }

      if( CurrentCtrl->struct_sign == MP_ID_COMBO )
      {
         // setup edit control
         int x, y, cx, cy;
         x = ValueRc.left; y = ValueRc.top;
         cx = ValueRc.right - ValueRc.left;
         cy = ValueRc.bottom - ValueRc.top - 6;
         MyCComboBox.SetWindowPos( NULL, x, y, cx, cy, SWP_NOZORDER );
         // ensure ccombobox visible
         if( ValueRc.bottom > wrc.bottom - 21 )
         {
            MyCComboBox.ShowWindow( SW_HIDE );
         }else{
            MyCComboBox.ShowWindow( SW_SHOW );
         }
      }

      if( CurrentCtrl->struct_sign == MP_ID_COLOR ||
          CurrentCtrl->struct_sign == MP_ID_FONT )
      {
         // setup edit control
         int x, y, cx, cy;
         x = ValueRc.left + 2; y = ValueRc.top + 2;
         cx = ValueRc.right - ValueRc.left - 4;
         cy = ValueRc.bottom - ValueRc.top - 4;
         MyCButton.SetWindowPos( NULL, x + cx - 25, y, 25, cy, SWP_NOZORDER );
         // ensure ccombobox visible
         if( ValueRc.bottom > wrc.bottom - 21 )
         {
            MyCButton.ShowWindow( SW_HIDE );
         }else{
            MyCButton.ShowWindow( SW_SHOW );
         }
      }

   }
   Invalidate();
}


