#if !defined(AFX_MYPROPS_H__D7844E2F_A299_48A6_ABAB_B9727957D988__INCLUDED_)
#define AFX_MYPROPS_H__D7844E2F_A299_48A6_ABAB_B9727957D988__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//---------------------------------------------------------------------------------------
#define MP_MAXCOUNT         100

#define MP_ID_NONE          0
#define MP_ID_EDIT          1
#define MP_ID_BOOLEAN       2
#define MP_ID_COMBO         3
#define MP_ID_COLOR         4
#define MP_ID_FONT          5

#define MP_CBT_DROPDOWN     0
#define MP_CBT_DROPDOWNLIST 1

#define MYCEDIT_ID          0x9001
#define MYCBUTTON_ID        0x9002
#define MYCCOMBOBOX_ID      0x9003

#define MP_UPANDDOWNTIMERID 0x997

//---------------------------------------------------------------------------------------
struct CMyPropStruct
{
   UINT   struct_sign;

   // std members
   int    Index;
   char   isSelected;
   char   PropName[ 64 ];
   char   isEnabled;

   // Contructor & Destructor
   CMyPropStruct( void ){ struct_sign = MP_ID_NONE; Index = -1; isSelected = 0; PropName[ 0 ] = 0; isEnabled = 1; };
   ~CMyPropStruct( void ){};
};


//---------------------------------------------------------------------------------------
struct CMyPropEditStruct
{
   UINT   struct_sign;// MP_ID_EDIT

   // std members
   int    Index;
   char   isSelected;
   char   PropName[ 64 ];
   char   isEnabled;

   // integral members
   char   EditText[ MAX_PATH ];
   char   isFileName;
   OPENFILENAME ofn;
   char   isNumber;
   char   isReadOnly;

   // Contructor & Destructor
   CMyPropEditStruct( void ){ struct_sign = MP_ID_EDIT; Index = -1; isSelected = 0; 
                              PropName[ 0 ] = 0; isEnabled = 1; EditText[ 0 ] = 0; 
                              isFileName = 0; isNumber = 0; isReadOnly = 0;
   };
   ~CMyPropEditStruct( void ){};
};


//---------------------------------------------------------------------------------------
struct CMyPropBoolStruct
{
   UINT   struct_sign;//MP_ID_BOOLEAN

   // std members
   int    Index;
   char   isSelected;
   char   PropName[ 64 ];
   char   isEnabled;

   // integral members
   bool   Result;

   // Contructor & Destructor
   CMyPropBoolStruct( void ){ struct_sign = MP_ID_BOOLEAN; Index = -1; isSelected = 0; PropName[ 0 ] = 0; isEnabled = 1;
                              Result = false;
   };
   ~CMyPropBoolStruct( void ){};
};


//---------------------------------------------------------------------------------------
struct CMyPropComboStruct
{
   UINT   struct_sign;//MP_ID_COMBO

   // std members
   int    Index;
   char   isSelected;
   char   PropName[ 64 ];
   char   isEnabled;

   // integral members
   char   Combotype;
   int    SelIndex;
   char   SelText[ 64 ];
   int    NumOfStrings;// max is 20!
   char   Strings[ 20 ][ 64 ];

   // Contructor & Destructor
   CMyPropComboStruct( void ){ struct_sign = MP_ID_COMBO; Index = -1; isSelected = 0; PropName[ 0 ] = 0; isEnabled = 1;
                               Combotype = MP_CBT_DROPDOWNLIST; SelIndex = 0; SelText[ 0 ]; NumOfStrings = 0;
   };
   ~CMyPropComboStruct( void ){};
};


//---------------------------------------------------------------------------------------
struct CMyPropColorStruct
{
   UINT   struct_sign;//MP_ID_COLOR

   // std members
   int    Index;
   char   isSelected;
   char   PropName[ 64 ];
   char   isEnabled;

   // integral members
   COLORREF Color;

   // Contructor & Destructor
   CMyPropColorStruct( void ){ struct_sign = MP_ID_COLOR; Index = -1; isSelected = 0; PropName[ 0 ] = 0; isEnabled = 1;
                               Color = 0;
   };
   ~CMyPropColorStruct( void ){};
};


//---------------------------------------------------------------------------------------
struct CMyPropFontStruct
{
   UINT   struct_sign;//MP_ID_FONT

   // std members
   int    Index;
   char   isSelected;
   char   PropName[ 64 ];
   char   isEnabled;

   // integral members
   char   FontName[ 100 ];
   BYTE   FontSize;
   BYTE   CharSet;
   BYTE   isStrikeOut;
   BYTE   isItalic;
   BYTE   isUnderline;
   BYTE   isBold;

   // Contructor & Destructor
   CMyPropFontStruct( void ){ struct_sign = MP_ID_FONT; Index = -1; isSelected = 0; PropName[ 0 ] = 0; isEnabled = 1;
                              FontName[ 0 ] = 0; FontSize = 8; CharSet = DEFAULT_CHARSET;
                              isStrikeOut = 0; isItalic = 0; isUnderline = 0; isBold = 0;
   };
   ~CMyPropFontStruct( void ){};
};


//---------------------------------------------------------------------------------------
class CMyProps : public CWnd
{
   //{{AFX_VIRTUAL(CMyProps)
	protected:
   virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL
protected:
   //{{AFX_MSG(CMyProps)
   afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
   afx_msg void OnMouseMove(UINT nFlags, CPoint point);
   afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
   afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
   DECLARE_MESSAGE_MAP()

   // ------------------- my data
   int            NumOfStructs;
   void          *Structs_ptr[ MP_MAXCOUNT ];
   CFont          OurFont;
   void           PaintOurProperties( CDC *cdc );
   int            HeaderDeviderPos;
   char           isHeaderDragging;
   int            HeaderDragPos;
   CEdit          MyCEdit;
   CButton        MyCButton;
   CComboBox      MyCComboBox;
   CColorDialog   MyCColorDialog;
   void           CreateControls( void );
   CMyPropStruct *CurrentCtrl;
   int            TopItem;
   int            NumOfItemsCanBeDisplayed;
   char           isUpPressed;
   char           isDownPressed;
   char           isUpAndDown;
   char           UpAndDownTimerCount;

   void           CalculationsByWindowSize( void );
public:
	               CMyProps();
	virtual       ~CMyProps();
   int            AddStruct( void *struct_ptr, int struct_len );
   void           RedrawCtrl( CMyPropStruct *ctrl, CDC *cdc = NULL );
   void           DeselectAll( void );
   CMyPropStruct *GetCtrlUnderPtr( POINT pt );
   CMyPropStruct *GetCtrl( int Num ){ if( Num > NumOfStructs ) return false; return (CMyPropStruct*)Structs_ptr[ Num ]; };
   void           LastCtrlUpdate( void );
   void           InvalidateCtrls( void );
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYPROPS_H__D7844E2F_A299_48A6_ABAB_B9727957D988__INCLUDED_)
